/**********************

 QDP_DF3 header file

**********************/

#ifndef _QDP_DF3
#define _QDP_DF3

#include "qdp_common.h"
#include "qdp_types.h"
#include "qla_types.h"
#include "qla_complex.h"
#include "qla_random.h"

#ifdef __cplusplus
extern "C" {
#endif

/* create and destroy fields */


/* data access and extraction */


/* optimization */


/* set by function */


/* shift */


/* shift & multiply */


/*
 *  Type conversion and component extraction and insertion
 */

/*
 *  Convert float to double
 */

void QDP_DF3_V_eq_V( QDP_D3_ColorVector *__restrict__ dest, QDP_F3_ColorVector *src, QDP_Subset subset );
void QDP_DF3_H_eq_H( QDP_D3_HalfFermion *__restrict__ dest, QDP_F3_HalfFermion *src, QDP_Subset subset );
void QDP_DF3_D_eq_D( QDP_D3_DiracFermion *__restrict__ dest, QDP_F3_DiracFermion *src, QDP_Subset subset );
void QDP_DF3_M_eq_M( QDP_D3_ColorMatrix *__restrict__ dest, QDP_F3_ColorMatrix *src, QDP_Subset subset );
void QDP_DF3_P_eq_P( QDP_D3_DiracPropagator *__restrict__ dest, QDP_F3_DiracPropagator *src, QDP_Subset subset );

/*
 *  Convert double to float
 */

void QDP_FD3_V_eq_V( QDP_F3_ColorVector *__restrict__ dest, QDP_D3_ColorVector *src, QDP_Subset subset );
void QDP_FD3_H_eq_H( QDP_F3_HalfFermion *__restrict__ dest, QDP_D3_HalfFermion *src, QDP_Subset subset );
void QDP_FD3_D_eq_D( QDP_F3_DiracFermion *__restrict__ dest, QDP_D3_DiracFermion *src, QDP_Subset subset );
void QDP_FD3_M_eq_M( QDP_F3_ColorMatrix *__restrict__ dest, QDP_D3_ColorMatrix *src, QDP_Subset subset );
void QDP_FD3_P_eq_P( QDP_F3_DiracPropagator *__restrict__ dest, QDP_D3_DiracPropagator *src, QDP_Subset subset );

#ifdef __cplusplus
}
#endif

#ifdef QDP_PROFILE
#include "qdp_df3_profile.h"
#endif

#endif
