/* QDP profiling header for INT */

#ifndef _QDP_INT_PROFILE_H
#define _QDP_INT_PROFILE_H
#define QDP_I_eq_func(_dest, _func, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_func"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_func(_dest, _func, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_func(_dest, _func, _subset); \
  } \
}
#define QDP_I_eq_sI(_dest, _src, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_I_eq_sI(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_I_eq_sI(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_I_eq_sI(_dest, _src, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_I_eq_sI(_dest, _src, _shift, _fb, _subset); \
  } \
}
#define QDP_I_veq_sI(_dest, _src, _shift, _fb, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_I_veq_sI(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_I_veq_sI(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_I_veq_sI(_dest, _src, _shift, _fb, _subset, _nv); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += _nv*QDP_subset_len(_subset); \
  } else { \
    QDP_I_veq_sI(_dest, _src, _shift, _fb, _subset, _nv); \
  } \
}
#define QDP_I_eq_zero(_dest, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_zero"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_zero(_dest, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_zero(_dest, _subset); \
  } \
}
#define QDP_I_eq_i(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_i"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_i(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_i(_dest, _src, _subset); \
  } \
}
#define QDP_S_eq_seed_i_I(_dest, _c, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_S_eq_seed_i_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_S_eq_seed_i_I(_dest, _c, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_S_eq_seed_i_I(_dest, _c, _src, _subset); \
  } \
}
#define QDP_I_eq_not_I(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_not_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_not_I(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_not_I(_dest, _src, _subset); \
  } \
}
#define QDP_S_eq_S(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_S_eq_S"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_S_eq_S(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_S_eq_S(_dest, _src, _subset); \
  } \
}
#define QDP_I_eq_I(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I(_dest, _src, _subset); \
  } \
}
#define QDP_S_veq_S(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_S_veq_S"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_S_veq_S(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_S_veq_S(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_I_veq_I(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_veq_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_veq_I(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_veq_I(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_I_eqm_I(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eqm_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eqm_I(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eqm_I(_dest, _src, _subset); \
  } \
}
#define QDP_I_peq_I(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_peq_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_peq_I(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_peq_I(_dest, _src, _subset); \
  } \
}
#define QDP_I_meq_I(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_meq_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_meq_I(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_meq_I(_dest, _src, _subset); \
  } \
}
#define QDP_I_veqm_I(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_veqm_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_veqm_I(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_veqm_I(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_I_vpeq_I(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_vpeq_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_vpeq_I(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_vpeq_I(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_I_vmeq_I(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_vmeq_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_vmeq_I(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_vmeq_I(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_I_eq_i_times_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_i_times_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_i_times_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_i_times_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_peq_i_times_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_peq_i_times_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_peq_i_times_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_peq_i_times_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_meq_i_times_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_meq_i_times_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_meq_i_times_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_meq_i_times_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eqm_i_times_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eqm_i_times_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eqm_i_times_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eqm_i_times_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_lshift_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_lshift_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_lshift_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_lshift_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_rshift_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_rshift_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_rshift_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_rshift_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_mod_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_mod_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_mod_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_mod_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_max_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_max_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_max_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_max_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_min_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_min_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_min_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_min_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_or_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_or_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_or_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_or_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_and_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_and_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_and_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_and_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_xor_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_xor_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_xor_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_xor_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_plus_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_plus_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_plus_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_plus_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_minus_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_minus_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_minus_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_minus_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_times_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_times_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_times_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_times_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_peq_I_times_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_peq_I_times_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_peq_I_times_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_peq_I_times_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_meq_I_times_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_meq_I_times_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_meq_I_times_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_meq_I_times_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eqm_I_times_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eqm_I_times_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eqm_I_times_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eqm_I_times_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_divide_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_divide_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_divide_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_divide_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_i_times_I_plus_I(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_i_times_I_plus_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_i_times_I_plus_I(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_i_times_I_plus_I(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_i_times_I_minus_I(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_i_times_I_minus_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_i_times_I_minus_I(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_i_times_I_minus_I(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_eq_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_eq_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_eq_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_eq_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_ne_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_ne_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_ne_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_ne_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_gt_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_gt_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_gt_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_gt_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_lt_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_lt_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_lt_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_lt_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_ge_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_ge_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_ge_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_ge_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_le_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_le_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_le_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_le_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_I_eq_I_mask_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_I_eq_I_mask_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_I_eq_I_mask_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_I_eq_I_mask_I(_dest, _src1, _src2, _subset); \
  } \
}

#endif
