/*
 *  Ternary operations with fields
 *
 *  Addition or subtraction with complex scalar multiplication
 */

#include "qdp_d_internal.h"

void
QDP_D_C_eq_c_times_C_plus_C( QDP_D_Complex *__restrict__ dest, QLA_D_Complex *c, QDP_D_Complex *src1, QDP_D_Complex *src2, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src1->dc);
  QDP_prepare_src(&src2->dc);

  if( subset->indexed ) {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_D_C_xeq_c_times_pC_plus_pC( dest->data, c, src1->ptr, src2->ptr, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_D_C_xeq_c_times_pC_plus_C( dest->data, c, src1->ptr, src2->data, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_D_C_xeq_c_times_C_plus_pC( dest->data, c, src1->data, src2->ptr, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_D_C_xeq_c_times_C_plus_C( dest->data, c, src1->data, src2->data, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      }
    }
  } else {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_D_C_veq_c_times_pC_plus_pC( dest->data+subset->offset, c, src1->ptr+subset->offset, src2->ptr+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_D_C_veq_c_times_pC_plus_C( dest->data+subset->offset, c, src1->ptr+subset->offset, src2->data+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_D_C_veq_c_times_C_plus_pC( dest->data+subset->offset, c, src1->data+subset->offset, src2->ptr+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_D_C_veq_c_times_C_plus_C( dest->data+subset->offset, c, src1->data+subset->offset, src2->data+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      }
    }
  }
}
