/*
 *  Reductions
 *
 *  Multisubset global sums
 */

#include "qdp_d_internal.h"

void
QDP_D_c_eq_sum_C_multi( QLA_D_Complex dest[], QDP_D_Complex *src, QDP_Subset subset[], int ns )
{
  int i;
  QLA_Q_Complex *dtemp;
  dtemp = (QLA_Q_Complex *) malloc(ns*sizeof(QLA_Q_Complex));
  QDP_prepare_src(&src->dc);

  for(i=0; i<ns; i++) {
  if( subset[i]->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD_c_xeq_sum_pC( &dtemp[i], src->ptr, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD_c_xeq_sum_C( &dtemp[i], src->data, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD_c_veq_sum_pC( &dtemp[i], src->ptr+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD_c_veq_sum_C( &dtemp[i], src->data+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  }
  }
  QDP_binary_reduce_multi(QLA_Q_C_vpeq_C, sizeof(QLA_Q_Complex), dtemp, ns);
  QLA_DQ_C_veq_C(dest, dtemp, ns);
  free(dtemp);
}
