/*
 *  Reductions
 *
 *  Multisubset inner products
 */

#include "qdp_d_internal.h"

void
QDP_D_c_veq_C_dot_C_multi( QLA_D_Complex dest[], QDP_D_Complex *src1[], QDP_D_Complex *src2[], QDP_Subset subset[], int ns )
{
  int i;
  QLA_Q_Complex *dtemp;
  dtemp = (QLA_Q_Complex *) malloc(ns*sizeof(QLA_Q_Complex));
  for(i=0; i<ns; ++i) {
    QDP_prepare_src(&src1[i]->dc);
    QDP_prepare_src(&src2[i]->dc);
  }

  for(i=0; i<ns; ++i) {
    if( subset[i]->indexed ) {
      if( src1[i]->ptr ) {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_QD_c_xeq_pC_dot_pC( &dtemp[i], src1[i]->ptr, src2[i]->ptr, subset[i]->index, subset[i]->len );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_QD_c_xeq_pC_dot_C( &dtemp[i], src1[i]->ptr, src2[i]->data, subset[i]->index, subset[i]->len );
          //QDP_math_time += QDP_time();
        }
      } else {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_QD_c_xeq_C_dot_pC( &dtemp[i], src1[i]->data, src2[i]->ptr, subset[i]->index, subset[i]->len );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_QD_c_xeq_C_dot_C( &dtemp[i], src1[i]->data, src2[i]->data, subset[i]->index, subset[i]->len );
          //QDP_math_time += QDP_time();
        }
      }
    } else {
      if( src1[i]->ptr ) {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_QD_c_veq_pC_dot_pC( &dtemp[i], src1[i]->ptr+subset[i]->offset, src2[i]->ptr+subset[i]->offset, subset[i]->len );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_QD_c_veq_pC_dot_C( &dtemp[i], src1[i]->ptr+subset[i]->offset, src2[i]->data+subset[i]->offset, subset[i]->len );
          //QDP_math_time += QDP_time();
        }
      } else {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_QD_c_veq_C_dot_pC( &dtemp[i], src1[i]->data+subset[i]->offset, src2[i]->ptr+subset[i]->offset, subset[i]->len );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_QD_c_veq_C_dot_C( &dtemp[i], src1[i]->data+subset[i]->offset, src2[i]->data+subset[i]->offset, subset[i]->len );
          //QDP_math_time += QDP_time();
        }
      }
    }
  }
  QDP_binary_reduce_multi(QLA_Q_C_vpeq_C, sizeof(QLA_Q_Complex), dtemp, ns);
  QLA_DQ_C_veq_C(dest, dtemp, ns);
  free(dtemp);
}
