/*
 *  Reductions
 *
 *  Global squared norm: uniform precision
 */

#include "qdp_d_internal.h"

void
QDP_D_r_eq_norm2_C( QLA_D_Real *__restrict__ dest, QDP_D_Complex *src, QDP_Subset subset )
{
  QLA_Q_Real dtemp;
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD_r_xeq_norm2_pC( &dtemp, src->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD_r_xeq_norm2_C( &dtemp, src->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD_r_veq_norm2_pC( &dtemp, src->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD_r_veq_norm2_C( &dtemp, src->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
  QDP_binary_reduce(QLA_Q_R_peq_R, sizeof(QLA_Q_Real), &dtemp);
  QLA_DQ_R_eq_R(dest, &dtemp);
}
