/*
 *  Reductions
 *
 *  Multisubset inner products
 */

#include "qdp_d_internal.h"

void
QDP_D_r_veq_I_dot_I_multi( QLA_D_Real dest[], QDP_Int *src1[], QDP_Int *src2[], QDP_Subset subset[], int ns )
{
  int i;
  QLA_Q_Real *dtemp;
  dtemp = (QLA_Q_Real *) malloc(ns*sizeof(QLA_Q_Real));
  for(i=0; i<ns; ++i) {
    QDP_prepare_src(&src1[i]->dc);
    QDP_prepare_src(&src2[i]->dc);
  }

  for(i=0; i<ns; ++i) {
    if( subset[i]->indexed ) {
      if( src1[i]->ptr ) {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_D_r_xeq_pI_dot_pI( &dest[i], src1[i]->ptr, src2[i]->ptr, subset[i]->index, subset[i]->len );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_D_r_xeq_pI_dot_I( &dest[i], src1[i]->ptr, src2[i]->data, subset[i]->index, subset[i]->len );
          //QDP_math_time += QDP_time();
        }
      } else {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_D_r_xeq_I_dot_pI( &dest[i], src1[i]->data, src2[i]->ptr, subset[i]->index, subset[i]->len );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_D_r_xeq_I_dot_I( &dest[i], src1[i]->data, src2[i]->data, subset[i]->index, subset[i]->len );
          //QDP_math_time += QDP_time();
        }
      }
    } else {
      if( src1[i]->ptr ) {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_D_r_veq_pI_dot_pI( &dest[i], src1[i]->ptr+subset[i]->offset, src2[i]->ptr+subset[i]->offset, subset[i]->len );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_D_r_veq_pI_dot_I( &dest[i], src1[i]->ptr+subset[i]->offset, src2[i]->data+subset[i]->offset, subset[i]->len );
          //QDP_math_time += QDP_time();
        }
      } else {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_D_r_veq_I_dot_pI( &dest[i], src1[i]->data+subset[i]->offset, src2[i]->ptr+subset[i]->offset, subset[i]->len );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_D_r_veq_I_dot_I( &dest[i], src1[i]->data+subset[i]->offset, src2[i]->data+subset[i]->offset, subset[i]->len );
          //QDP_math_time += QDP_time();
        }
      }
    }
  }
  QDP_binary_reduce_multi(QLA_D_R_vpeq_R, sizeof(QLA_D_Real), dest, ns);
}
