/*
 *  Reductions
 *
 *  Global inner product
 */

#include "qdp_d_internal.h"

void
QDP_D_r_veq_R_dot_R( QLA_D_Real dest[], QDP_D_Real *src1[], QDP_D_Real *src2[], QDP_Subset subset, int nv )
{
  int i, offset, blen;
  QLA_Q_Real *dtemp;
  dtemp = (QLA_Q_Real *) malloc(nv*sizeof(QLA_Q_Real));
  QLA_Q_R_veq_zero(dtemp, nv);
  for(i=0; i<nv; ++i) {
    QDP_prepare_src(&src1[i]->dc);
    QDP_prepare_src(&src2[i]->dc);
  }

  offset = 0;
  blen = QDP_block_size;
  while(1) {
    if( blen > subset->len - offset ) blen = subset->len - offset;
    if( blen <= 0) break;
    for(i=0; i<nv; ++i) {
    if( subset->indexed ) {
      if( src1[i]->ptr ) {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_QD_r_xpeq_pR_dot_pR( &dtemp[i], src1[i]->ptr, src2[i]->ptr, subset->index+offset, blen );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_QD_r_xpeq_pR_dot_R( &dtemp[i], src1[i]->ptr, src2[i]->data, subset->index+offset, blen );
          //QDP_math_time += QDP_time();
        }
      } else {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_QD_r_xpeq_R_dot_pR( &dtemp[i], src1[i]->data, src2[i]->ptr, subset->index+offset, blen );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_QD_r_xpeq_R_dot_R( &dtemp[i], src1[i]->data, src2[i]->data, subset->index+offset, blen );
          //QDP_math_time += QDP_time();
        }
      }
    } else {
      if( src1[i]->ptr ) {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_QD_r_vpeq_pR_dot_pR( &dtemp[i], src1[i]->ptr+subset->offset+offset, src2[i]->ptr+subset->offset+offset, blen );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_QD_r_vpeq_pR_dot_R( &dtemp[i], src1[i]->ptr+subset->offset+offset, src2[i]->data+subset->offset+offset, blen );
          //QDP_math_time += QDP_time();
        }
      } else {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_QD_r_vpeq_R_dot_pR( &dtemp[i], src1[i]->data+subset->offset+offset, src2[i]->ptr+subset->offset+offset, blen );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_QD_r_vpeq_R_dot_R( &dtemp[i], src1[i]->data+subset->offset+offset, src2[i]->data+subset->offset+offset, blen );
          //QDP_math_time += QDP_time();
        }
      }
    }
    }
    offset += blen;
  }
  QDP_binary_reduce_multi(QLA_Q_R_vpeq_R, sizeof(QLA_Q_Real), dtemp, nv);
  QLA_DQ_R_veq_R(dest, dtemp, nv);
  free(dtemp);
}
