/*
 *  Reductions
 *
 *  Global squared norm: uniform precision
 */

#include "qdp_d_internal.h"

void
QDP_D_r_veq_norm2_I( QLA_D_Real dest[], QDP_Int *src[], QDP_Subset subset, int nv )
{
  int i, offset, blen;
  QLA_Q_Real *dtemp;
  dtemp = (QLA_Q_Real *) malloc(nv*sizeof(QLA_Q_Real));
  QLA_Q_R_veq_zero(dtemp, nv);
  for(i=0; i<nv; ++i) {
    QDP_prepare_src(&src[i]->dc);
  }

  offset = 0;
  blen = QDP_block_size;
  while(1) {
    if( blen > subset->len - offset ) blen = subset->len - offset;
    if( blen <= 0) break;
    for(i=0; i<nv; ++i) {
    if( subset->indexed ) {
      if( src[i]->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_D_r_xpeq_norm2_pI( &dest[i], src[i]->ptr, subset->index+offset, blen );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_D_r_xpeq_norm2_I( &dest[i], src[i]->data, subset->index+offset, blen );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src[i]->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_D_r_vpeq_norm2_pI( &dest[i], src[i]->ptr+subset->offset+offset, blen );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_D_r_vpeq_norm2_I( &dest[i], src[i]->data+subset->offset+offset, blen );
        //QDP_math_time += QDP_time();
      }
    }
    }
    offset += blen;
  }
  QDP_binary_reduce_multi(QLA_D_R_vpeq_R, sizeof(QLA_D_Real), dest, nv);
}
