/*
 *  Type conversion and component extraction and insertion
 *
 *  Accessing a color matrix element
 */

#include "qdp_d3_internal.h"

void
QDP_D3_C_eq_elem_M( QDP_D_Complex *__restrict__ dest, QDP_D3_ColorMatrix *src, int i, int j, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_C_xeq_elem_pM( dest->data, src->ptr, i, j, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_C_xeq_elem_M( dest->data, src->data, i, j, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_C_veq_elem_pM( dest->data+subset->offset, src->ptr+subset->offset, i, j, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_C_veq_elem_M( dest->data+subset->offset, src->data+subset->offset, i, j, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
