/*
 *  Binary operations with constants
 *
 *  Left multiplication by gamma matrix
 */

#include "qdp_d3_internal.h"

void
QDP_D3_D_eq_gamma_times_D( QDP_D3_DiracFermion *__restrict__ dest, QDP_D3_DiracFermion *src, int i, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_D_xeq_gamma_times_pD( dest->data, src->ptr, i, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_D_xeq_gamma_times_D( dest->data, src->data, i, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_D_veq_gamma_times_pD( dest->data+subset->offset, src->ptr+subset->offset, i, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_D_veq_gamma_times_D( dest->data+subset->offset, src->data+subset->offset, i, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
