/*
 *  Binary operations with constants
 *
 *  Multiplication by real constant
 */

#include "qdp_d3_internal.h"

void
QDP_D3_D_peq_r_times_D( QDP_D3_DiracFermion *__restrict__ dest, QLA_D_Real *src1, QDP_D3_DiracFermion *src2, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src2->dc);

  if( subset->indexed ) {
    if( src2->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_D_xpeq_r_times_pD( dest->data, src1, src2->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_D_xpeq_r_times_D( dest->data, src1, src2->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src2->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_D_vpeq_r_times_pD( dest->data+subset->offset, src1, src2->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_D_vpeq_r_times_D( dest->data+subset->offset, src1, src2->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
