/*
 *  Type conversion and component extraction and insertion
 *
 *  Matrix multiply and Dirac spin reconstruction
 */

#include "qdp_d3_internal.h"

void
QDP_D3_D_peq_sprecon_M_times_H( QDP_D3_DiracFermion *__restrict__ dest, QDP_D3_ColorMatrix *src1, QDP_D3_HalfFermion *src2, int dir, int sign, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src1->dc);
  QDP_prepare_src(&src2->dc);

  if( subset->indexed ) {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_D3_D_xpeq_sprecon_pM_times_pH( dest->data, src1->ptr, src2->ptr, dir, sign, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_D3_D_xpeq_sprecon_pM_times_H( dest->data, src1->ptr, src2->data, dir, sign, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_D3_D_xpeq_sprecon_M_times_pH( dest->data, src1->data, src2->ptr, dir, sign, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_D3_D_xpeq_sprecon_M_times_H( dest->data, src1->data, src2->data, dir, sign, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      }
    }
  } else {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_D3_D_vpeq_sprecon_pM_times_pH( dest->data+subset->offset, src1->ptr+subset->offset, src2->ptr+subset->offset, dir, sign, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_D3_D_vpeq_sprecon_pM_times_H( dest->data+subset->offset, src1->ptr+subset->offset, src2->data+subset->offset, dir, sign, subset->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_D3_D_vpeq_sprecon_M_times_pH( dest->data+subset->offset, src1->data+subset->offset, src2->ptr+subset->offset, dir, sign, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_D3_D_vpeq_sprecon_M_times_H( dest->data+subset->offset, src1->data+subset->offset, src2->data+subset->offset, dir, sign, subset->len );
        //QDP_math_time += QDP_time();
      }
    }
  }
}
