/*
 *  Type conversion and component extraction and insertion
 *
 *  Inserting a color vector into a half fermion or Dirac fermion
 */

#include "qdp_d3_internal.h"

void
QDP_D3_H_eq_colorvec_V( QDP_D3_HalfFermion *__restrict__ dest, QDP_D3_ColorVector *src, int spin, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_H_xeq_colorvec_pV( dest->data, src->ptr, spin, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_H_xeq_colorvec_V( dest->data, src->data, spin, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_H_veq_colorvec_pV( dest->data+subset->offset, src->ptr+subset->offset, spin, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_H_veq_colorvec_V( dest->data+subset->offset, src->data+subset->offset, spin, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
