/*
 *  Type conversion and component extraction and insertion
 *
 *  Inserting a half fermion or Dirac fermion spinor element
 */

#include "qdp_d3_internal.h"

void
QDP_D3_H_eq_elem_C( QDP_D3_HalfFermion *__restrict__ dest, QDP_D_Complex *src, int color, int spin, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_H_xeq_elem_pC( dest->data, src->ptr, color, spin, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_H_xeq_elem_C( dest->data, src->data, color, spin, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_H_veq_elem_pC( dest->data+subset->offset, src->ptr+subset->offset, color, spin, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_H_veq_elem_C( dest->data+subset->offset, src->data+subset->offset, color, spin, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
