/*
 *  Type conversion and component extraction and insertion
 *
 *  Dirac spin projection
 */

#include "qdp_d3_internal.h"

void
QDP_D3_H_veq_spproj_D( QDP_D3_HalfFermion *__restrict__ dest[], QDP_D3_DiracFermion *src[], int dir[], int sign[], QDP_Subset subset, int nv )
{
  int i, offset, blen;
  for(i=0; i<nv; ++i) {
    QDP_prepare_dest(&dest[i]->dc);
    QDP_prepare_src(&src[i]->dc);
  }

  offset = 0;
  blen = QDP_block_size;
  while(1) {
    if( blen > subset->len - offset ) blen = subset->len - offset;
    if( blen <= 0) break;
    for(i=0; i<nv; ++i) {
    if( subset->indexed ) {
      if( src[i]->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_D3_H_xeq_spproj_pD( dest[i]->data, src[i]->ptr, dir[i], sign[i], subset->index+offset, blen );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_D3_H_xeq_spproj_D( dest[i]->data, src[i]->data, dir[i], sign[i], subset->index+offset, blen );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src[i]->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_D3_H_veq_spproj_pD( dest[i]->data+subset->offset+offset, src[i]->ptr+subset->offset+offset, dir[i], sign[i], blen );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_D3_H_veq_spproj_D( dest[i]->data+subset->offset+offset, src[i]->data+subset->offset+offset, dir[i], sign[i], blen );
        //QDP_math_time += QDP_time();
      }
    }
    }
    offset += blen;
  }
}
