/*
 *  Type conversion and component extraction and insertion
 *
 *  Inserting a color matrix element
 */

#include "qdp_d3_internal.h"

void
QDP_D3_M_eq_elem_C( QDP_D3_ColorMatrix *__restrict__ dest, QDP_D_Complex *src, int i, int j, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_xeq_elem_pC( dest->data, src->ptr, i, j, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_xeq_elem_C( dest->data, src->data, i, j, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_veq_elem_pC( dest->data+subset->offset, src->ptr+subset->offset, i, j, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_veq_elem_C( dest->data+subset->offset, src->data+subset->offset, i, j, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
