/*
 *  Type conversion and component extraction and insertion
 *
 *  Spin trace of Dirac propagator
 */

#include "qdp_d3_internal.h"

void
QDP_D3_M_eq_spintrace_P( QDP_D3_ColorMatrix *__restrict__ dest, QDP_D3_DiracPropagator *src, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_xeq_spintrace_pP( dest->data, src->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_xeq_spintrace_P( dest->data, src->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_veq_spintrace_pP( dest->data+subset->offset, src->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_veq_spintrace_P( dest->data+subset->offset, src->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
