/*
 *  Unary Operations
 *
 *  Transpose
 */

#include "qdp_d3_internal.h"

void
QDP_D3_M_eqm_transpose_M( QDP_D3_ColorMatrix *__restrict__ dest, QDP_D3_ColorMatrix *src, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_xeqm_transpose_pM( dest->data, src->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_xeqm_transpose_M( dest->data, src->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_veqm_transpose_pM( dest->data+subset->offset, src->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_veqm_transpose_M( dest->data+subset->offset, src->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
