/*
 *  Binary operations with constants
 *
 *  Multiplication by complex constant
 */

#include "qdp_d3_internal.h"

void
QDP_D3_M_peq_c_times_M( QDP_D3_ColorMatrix *__restrict__ dest, QLA_D_Complex *src1, QDP_D3_ColorMatrix *src2, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src2->dc);

  if( subset->indexed ) {
    if( src2->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_xpeq_c_times_pM( dest->data, src1, src2->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_xpeq_c_times_M( dest->data, src1, src2->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src2->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_vpeq_c_times_pM( dest->data+subset->offset, src1, src2->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_M_vpeq_c_times_M( dest->data+subset->offset, src1, src2->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
