/*
 *  Type conversion and component extraction and insertion
 *
 *  Real/Imaginary part of trace of color matrix
 */

#include "qdp_d3_internal.h"

void
QDP_D3_R_eq_re_trace_M( QDP_D_Real *__restrict__ dest, QDP_D3_ColorMatrix *src, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_R_xeq_re_trace_pM( dest->data, src->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_R_xeq_re_trace_M( dest->data, src->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_D3_R_veq_re_trace_pM( dest->data+subset->offset, src->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_D3_R_veq_re_trace_M( dest->data+subset->offset, src->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
