#include "qdp_d3.h"
#include "qdp_d3_internal.h"
#include "com_common.h"

void
QDP_D3_V_eq_sV(QDP_D3_ColorVector *__restrict__ dest, QDP_D3_ColorVector *src, QDP_Shift shift, QDP_ShiftDir fb, QDP_Subset subset)
{
  int restart;

  if(QDP_suspended) {
    fprintf(stderr,"QDP error: attempting shift while communications suspended\n");
    QDP_abort();
  }

  if((fb!=QDP_forward)&&(fb!=QDP_backward)) {
    fprintf(stderr,"QDP: error: bad fb in QDP_D3_V_eq_sV\n");
    QDP_abort();
  }

  restart = QDP_prepare_shift(&dest->dc, &src->dc, shift, fb, subset);

  if((restart)&&(dest->dc.shift_src->st->nv!=1)) {
    restart = 0;
    QDP_remove_shift_tag_reference(dest->dc.shift_src->st);
  }

  QDP_restart = restart;

  if(!restart) {

    dest->dc.shift_src->st = QDP_alloc_shift_tag(1);

    dest->dc.shift_src->st->msgtag =
      QDP_declare_shift( (char **)dest->ptr, (char *)src->data,
			 sizeof(QLA_D3_ColorVector), shift, fb, subset );

  }

  dest->dc.shift_src->st->shift_pending = 1;
  //QDP_comm_time -= QDP_time();
  QDP_do_gather(dest->dc.shift_src->st->msgtag);
  //QDP_comm_time += QDP_time();
}
