/*
 *  Reductions
 *
 *  Global sums
 */

#include "qdp_d3_internal.h"

void
QDP_D3_h_eq_sum_H( QLA_D3_HalfFermion *__restrict__ dest, QDP_D3_HalfFermion *src, QDP_Subset subset )
{
  QLA_Q3_HalfFermion dtemp;
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD3_h_xeq_sum_pH( &dtemp, src->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD3_h_xeq_sum_H( &dtemp, src->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD3_h_veq_sum_pH( &dtemp, src->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD3_h_veq_sum_H( &dtemp, src->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
  QDP_binary_reduce(QLA_Q3_H_peq_H, sizeof(QLA_Q3_HalfFermion), &dtemp);
  QLA_DQ3_H_eq_H(dest, &dtemp);
}
