/*
 *  Reductions
 *
 *  Multisubset global sums
 */

#include "qdp_d3_internal.h"

void
QDP_D3_m_eq_sum_M_multi( QLA_D3_ColorMatrix dest[], QDP_D3_ColorMatrix *src, QDP_Subset subset[], int ns )
{
  int i;
  QLA_Q3_ColorMatrix *dtemp;
  dtemp = (QLA_Q3_ColorMatrix *) malloc(ns*sizeof(QLA_Q3_ColorMatrix));
  QDP_prepare_src(&src->dc);

  for(i=0; i<ns; i++) {
  if( subset[i]->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD3_m_xeq_sum_pM( &dtemp[i], src->ptr, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD3_m_xeq_sum_M( &dtemp[i], src->data, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD3_m_veq_sum_pM( &dtemp[i], src->ptr+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD3_m_veq_sum_M( &dtemp[i], src->data+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  }
  }
  QDP_binary_reduce_multi(QLA_Q3_M_vpeq_M, sizeof(QLA_Q3_ColorMatrix), dtemp, ns);
  QLA_DQ3_M_veq_M(dest, dtemp, ns);
  free(dtemp);
}
