/*
 *  Reductions
 *
 *  Multisubset Norms
 */

#include "qdp_d3_internal.h"

void
QDP_D3_r_eq_norm2_M_multi( QLA_D_Real dest[], QDP_D3_ColorMatrix *src, QDP_Subset subset[], int ns )
{
  int i;
  QLA_Q_Real *dtemp;
  dtemp = (QLA_Q_Real *) malloc(ns*sizeof(QLA_Q_Real));
  QDP_prepare_src(&src->dc);

  for(i=0; i<ns; i++) {
  if( subset[i]->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD3_r_xeq_norm2_pM( &dtemp[i], src->ptr, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD3_r_xeq_norm2_M( &dtemp[i], src->data, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD3_r_veq_norm2_pM( &dtemp[i], src->ptr+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD3_r_veq_norm2_M( &dtemp[i], src->data+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  }
  }
  QDP_binary_reduce_multi(QLA_Q_R_vpeq_R, sizeof(QLA_Q_Real), dtemp, ns);
  QLA_DQ_R_veq_R(dest, dtemp, ns);
  free(dtemp);
}
