/*
 *  Reductions
 *
 *  Multisubset real part of global inner product
 */

#include "qdp_d3_internal.h"

void
QDP_D3_r_eq_re_M_dot_M_multi( QLA_D_Real dest[], QDP_D3_ColorMatrix *src1, QDP_D3_ColorMatrix *src2, QDP_Subset subset[], int ns )
{
  int i;
  QLA_Q_Real *dtemp;
  dtemp = (QLA_Q_Real *) malloc(ns*sizeof(QLA_Q_Real));
  QDP_prepare_src(&src1->dc);
  QDP_prepare_src(&src2->dc);

  for(i=0; i<ns; i++) {
  if( subset[i]->indexed ) {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_xeq_re_pM_dot_pM( &dtemp[i], src1->ptr, src2->ptr, subset[i]->index, subset[i]->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_xeq_re_pM_dot_M( &dtemp[i], src1->ptr, src2->data, subset[i]->index, subset[i]->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_xeq_re_M_dot_pM( &dtemp[i], src1->data, src2->ptr, subset[i]->index, subset[i]->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_xeq_re_M_dot_M( &dtemp[i], src1->data, src2->data, subset[i]->index, subset[i]->len );
        //QDP_math_time += QDP_time();
      }
    }
  } else {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_veq_re_pM_dot_pM( &dtemp[i], src1->ptr+subset[i]->offset, src2->ptr+subset[i]->offset, subset[i]->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_veq_re_pM_dot_M( &dtemp[i], src1->ptr+subset[i]->offset, src2->data+subset[i]->offset, subset[i]->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_veq_re_M_dot_pM( &dtemp[i], src1->data+subset[i]->offset, src2->ptr+subset[i]->offset, subset[i]->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_veq_re_M_dot_M( &dtemp[i], src1->data+subset[i]->offset, src2->data+subset[i]->offset, subset[i]->len );
        //QDP_math_time += QDP_time();
      }
    }
  }
  }
  QDP_binary_reduce_multi(QLA_Q_R_vpeq_R, sizeof(QLA_Q_Real), dtemp, ns);
  QLA_DQ_R_veq_R(dest, dtemp, ns);
  free(dtemp);
}
