/*
 *  Reductions
 *
 *  Real part of global inner product
 */

#include "qdp_d3_internal.h"

void
QDP_D3_r_eq_re_V_dot_V( QLA_D_Real *__restrict__ dest, QDP_D3_ColorVector *src1, QDP_D3_ColorVector *src2, QDP_Subset subset )
{
  QLA_Q_Real dtemp;
  QDP_prepare_src(&src1->dc);
  QDP_prepare_src(&src2->dc);

  if( subset->indexed ) {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_xeq_re_pV_dot_pV( &dtemp, src1->ptr, src2->ptr, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_xeq_re_pV_dot_V( &dtemp, src1->ptr, src2->data, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_xeq_re_V_dot_pV( &dtemp, src1->data, src2->ptr, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_xeq_re_V_dot_V( &dtemp, src1->data, src2->data, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      }
    }
  } else {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_veq_re_pV_dot_pV( &dtemp, src1->ptr+subset->offset, src2->ptr+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_veq_re_pV_dot_V( &dtemp, src1->ptr+subset->offset, src2->data+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_veq_re_V_dot_pV( &dtemp, src1->data+subset->offset, src2->ptr+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_QD3_r_veq_re_V_dot_V( &dtemp, src1->data+subset->offset, src2->data+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      }
    }
  }
  QDP_binary_reduce(QLA_Q_R_peq_R, sizeof(QLA_Q_Real), &dtemp);
  QLA_DQ_R_eq_R(dest, &dtemp);
}
