/*
 *  Reductions
 *
 *  Multisubset real part of global inner product
 */

#include "qdp_d3_internal.h"

void
QDP_D3_r_veq_re_H_dot_H_multi( QLA_D_Real dest[], QDP_D3_HalfFermion *src1[], QDP_D3_HalfFermion *src2[], QDP_Subset subset[], int ns )
{
  int i;
  QLA_Q_Real *dtemp;
  dtemp = (QLA_Q_Real *) malloc(ns*sizeof(QLA_Q_Real));
  for(i=0; i<ns; ++i) {
    QDP_prepare_src(&src1[i]->dc);
    QDP_prepare_src(&src2[i]->dc);
  }

  for(i=0; i<ns; ++i) {
    if( subset[i]->indexed ) {
      if( src1[i]->ptr ) {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_QD3_r_xeq_re_pH_dot_pH( &dtemp[i], src1[i]->ptr, src2[i]->ptr, subset[i]->index, subset[i]->len );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_QD3_r_xeq_re_pH_dot_H( &dtemp[i], src1[i]->ptr, src2[i]->data, subset[i]->index, subset[i]->len );
          //QDP_math_time += QDP_time();
        }
      } else {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_QD3_r_xeq_re_H_dot_pH( &dtemp[i], src1[i]->data, src2[i]->ptr, subset[i]->index, subset[i]->len );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_QD3_r_xeq_re_H_dot_H( &dtemp[i], src1[i]->data, src2[i]->data, subset[i]->index, subset[i]->len );
          //QDP_math_time += QDP_time();
        }
      }
    } else {
      if( src1[i]->ptr ) {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_QD3_r_veq_re_pH_dot_pH( &dtemp[i], src1[i]->ptr+subset[i]->offset, src2[i]->ptr+subset[i]->offset, subset[i]->len );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_QD3_r_veq_re_pH_dot_H( &dtemp[i], src1[i]->ptr+subset[i]->offset, src2[i]->data+subset[i]->offset, subset[i]->len );
          //QDP_math_time += QDP_time();
        }
      } else {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_QD3_r_veq_re_H_dot_pH( &dtemp[i], src1[i]->data+subset[i]->offset, src2[i]->ptr+subset[i]->offset, subset[i]->len );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_QD3_r_veq_re_H_dot_H( &dtemp[i], src1[i]->data+subset[i]->offset, src2[i]->data+subset[i]->offset, subset[i]->len );
          //QDP_math_time += QDP_time();
        }
      }
    }
  }
  QDP_binary_reduce_multi(QLA_Q_R_vpeq_R, sizeof(QLA_Q_Real), dtemp, ns);
  QLA_DQ_R_veq_R(dest, dtemp, ns);
  free(dtemp);
}
