/*
 *  Reductions
 *
 *  Global sums
 */

#include "qdp_d3_internal.h"

void
QDP_D3_v_eq_sum_V( QLA_D3_ColorVector *__restrict__ dest, QDP_D3_ColorVector *src, QDP_Subset subset )
{
  QLA_Q3_ColorVector dtemp;
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD3_v_xeq_sum_pV( &dtemp, src->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD3_v_xeq_sum_V( &dtemp, src->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD3_v_veq_sum_pV( &dtemp, src->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD3_v_veq_sum_V( &dtemp, src->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
  QDP_binary_reduce(QLA_Q3_V_peq_V, sizeof(QLA_Q3_ColorVector), &dtemp);
  QLA_DQ3_V_eq_V(dest, &dtemp);
}
