/*
 *  Reductions
 *
 *  Multisubset global sums
 */

#include "qdp_d3_internal.h"

void
QDP_D3_v_eq_sum_V_multi( QLA_D3_ColorVector dest[], QDP_D3_ColorVector *src, QDP_Subset subset[], int ns )
{
  int i;
  QLA_Q3_ColorVector *dtemp;
  dtemp = (QLA_Q3_ColorVector *) malloc(ns*sizeof(QLA_Q3_ColorVector));
  QDP_prepare_src(&src->dc);

  for(i=0; i<ns; i++) {
  if( subset[i]->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD3_v_xeq_sum_pV( &dtemp[i], src->ptr, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD3_v_xeq_sum_V( &dtemp[i], src->data, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_QD3_v_veq_sum_pV( &dtemp[i], src->ptr+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_QD3_v_veq_sum_V( &dtemp[i], src->data+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  }
  }
  QDP_binary_reduce_multi(QLA_Q3_V_vpeq_V, sizeof(QLA_Q3_ColorVector), dtemp, ns);
  QLA_DQ3_V_veq_V(dest, dtemp, ns);
  free(dtemp);
}
