#include <stdlib.h>
#include "qdp_d3_internal.h"
#include <qdp_string.h>

#undef N
#define N -1
#if (3+0) == -1
#define NC qf->nc,
#else
#define NC
#endif

#undef F
#undef D
#define F -1
#define D -1
#if (D+0) == -1
#define WS QDPIO_word_V(D)
#else
#define WS QDPIO_word_V(dummy)
#endif
#undef F
#undef D

/* Internal factory function for array of field data */
static void
QDP_D3_vget_V(char *buf, size_t index, int count, void *qfin)
{
  struct QDP_IO_field *qf = qfin;
  QDP_D3_ColorVector **field = (QDP_D3_ColorVector **)(qf->data);
  QLA_D3_ColorVector *src;
  QLA_D3_ColorVector *dest = (QLA_D3_ColorVector *)buf;
  int i;

/* For the site specified by "index", move an array of "count" data
   from the array of fields to the write buffer */
  for(i = 0; i < count; i++, dest++) {
    src = QDP_D3_expose_V( field[i] ) + index;
    QDPIO_get_V(NC, D, _D3, dest, src, qf->nc, QLA_Ns);
    QDP_D3_reset_V( field[i] );
  }
}

/* Internal factory function for global data */
static void
QDP_D3_vget_v(char *buf, size_t index, int count, void *qfin)
{
  struct QDP_IO_field *qf = qfin;
  QLA_D3_ColorVector *src = (QLA_D3_ColorVector *)(qf->data);
  QLA_D3_ColorVector *dest = (QLA_D3_ColorVector *)buf;
  int i;

  for(i = 0; i < count; i++, src++, dest++)
    QDPIO_get_V(NC, D, _D3, dest, src, qf->nc, QLA_Ns);
}

/* Write an array of QDP fields */
int
QDP_D3_vwrite_V(QDP_Writer *qdpw, QDP_String *md, QDP_D3_ColorVector *field[],
		    int nv)
{
  struct QDP_IO_field qf;
  int i, status;
  QIO_RecordInfo *rec_info;

  qf.data = (char *) field;
  qf.size = QDPIO_size_V(D, 3, QLA_Ns);
  qf.nc = 3;
  qf.word_size = WS;

  rec_info = QIO_create_record_info(QIO_FIELD, "QDP_D3_ColorVector", "D", 3,
				    QLA_Ns, qf.size, nv);

  for(i=0; i<nv; i++)
    QDP_prepare_dest( &field[i]->dc );

  status = QDP_write_check(qdpw, md, QIO_FIELD, QDP_D3_vget_V, &qf, nv,
			   rec_info);
  return status;
}

/* Write a single QDP field */
int
QDP_D3_write_V( QDP_Writer *qdpw, QDP_String *md, QDP_D3_ColorVector *f)
{
  QDP_D3_ColorVector *field[1];
  field[0] = f;
  return QDP_D3_vwrite_V(qdpw, md, field, 1);
}

/* Write a global array of QLA data */
int
QDP_D3_vwrite_v(QDP_Writer *qdpw, QDP_String *md, QLA_D3_ColorVector *array,
		       int count)
{
  struct QDP_IO_field qf;
  QIO_RecordInfo *rec_info;

  qf.data = (char *) array;
  qf.size = QDPIO_size_V(D, 3, QLA_Ns);
  qf.nc = 3;
  qf.word_size = WS;

  rec_info = QIO_create_record_info(QIO_GLOBAL, "QDP_D3_ColorVector", "D", 3,
				    QLA_Ns, qf.size, count);

  return QDP_write_check(qdpw, md, QIO_GLOBAL, QDP_D3_vget_v,
			 &qf, count, rec_info);
}
