/*
 *  Reductions
 *
 *  Global inner product
 */

#include "qdp_f_internal.h"

void
QDP_F_c_eq_C_dot_C( QLA_F_Complex *__restrict__ dest, QDP_F_Complex *src1, QDP_F_Complex *src2, QDP_Subset subset )
{
  QLA_D_Complex dtemp;
  QDP_prepare_src(&src1->dc);
  QDP_prepare_src(&src2->dc);

  if( subset->indexed ) {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF_c_xeq_pC_dot_pC( &dtemp, src1->ptr, src2->ptr, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF_c_xeq_pC_dot_C( &dtemp, src1->ptr, src2->data, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF_c_xeq_C_dot_pC( &dtemp, src1->data, src2->ptr, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF_c_xeq_C_dot_C( &dtemp, src1->data, src2->data, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      }
    }
  } else {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF_c_veq_pC_dot_pC( &dtemp, src1->ptr+subset->offset, src2->ptr+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF_c_veq_pC_dot_C( &dtemp, src1->ptr+subset->offset, src2->data+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF_c_veq_C_dot_pC( &dtemp, src1->data+subset->offset, src2->ptr+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF_c_veq_C_dot_C( &dtemp, src1->data+subset->offset, src2->data+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      }
    }
  }
  QDP_binary_reduce(QLA_D_C_peq_C, sizeof(QLA_D_Complex), &dtemp);
  QLA_FD_C_eq_C(dest, &dtemp);
}
