/*
 *  Type conversion and component extraction and insertion
 *
 *  Accessing a half fermion or Dirac fermion spinor element
 */

#include "qdp_f3_internal.h"

void
QDP_F3_C_eq_elem_D( QDP_F_Complex *__restrict__ dest, QDP_F3_DiracFermion *src, int color, int spin, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_F3_C_xeq_elem_pD( dest->data, src->ptr, color, spin, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_F3_C_xeq_elem_D( dest->data, src->data, color, spin, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_F3_C_veq_elem_pD( dest->data+subset->offset, src->ptr+subset->offset, color, spin, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_F3_C_veq_elem_D( dest->data+subset->offset, src->data+subset->offset, color, spin, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
