/*
 *  Type conversion and component extraction and insertion
 *
 *  Matrix multiply and Dirac spin reconstruction
 */

#include "qdp_f3_internal.h"

void
QDP_F3_D_vmeq_sprecon_M_times_H( QDP_F3_DiracFermion *__restrict__ dest[], QDP_F3_ColorMatrix *src1[], QDP_F3_HalfFermion *src2[], int dir[], int sign[], QDP_Subset subset, int nv )
{
  int i, offset, blen;
  for(i=0; i<nv; ++i) {
    QDP_prepare_dest(&dest[i]->dc);
    QDP_prepare_src(&src1[i]->dc);
    QDP_prepare_src(&src2[i]->dc);
  }

  offset = 0;
  blen = QDP_block_size;
  while(1) {
    if( blen > subset->len - offset ) blen = subset->len - offset;
    if( blen <= 0) break;
    for(i=0; i<nv; ++i) {
    if( subset->indexed ) {
      if( src1[i]->ptr ) {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_F3_D_xmeq_sprecon_pM_times_pH( dest[i]->data, src1[i]->ptr, src2[i]->ptr, dir[i], sign[i], subset->index+offset, blen );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_F3_D_xmeq_sprecon_pM_times_H( dest[i]->data, src1[i]->ptr, src2[i]->data, dir[i], sign[i], subset->index+offset, blen );
          //QDP_math_time += QDP_time();
        }
      } else {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_F3_D_xmeq_sprecon_M_times_pH( dest[i]->data, src1[i]->data, src2[i]->ptr, dir[i], sign[i], subset->index+offset, blen );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_F3_D_xmeq_sprecon_M_times_H( dest[i]->data, src1[i]->data, src2[i]->data, dir[i], sign[i], subset->index+offset, blen );
          //QDP_math_time += QDP_time();
        }
      }
    } else {
      if( src1[i]->ptr ) {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_F3_D_vmeq_sprecon_pM_times_pH( dest[i]->data+subset->offset+offset, src1[i]->ptr+subset->offset+offset, src2[i]->ptr+subset->offset+offset, dir[i], sign[i], blen );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_F3_D_vmeq_sprecon_pM_times_H( dest[i]->data+subset->offset+offset, src1[i]->ptr+subset->offset+offset, src2[i]->data+subset->offset+offset, dir[i], sign[i], blen );
          //QDP_math_time += QDP_time();
        }
      } else {
        if( src2[i]->ptr ) {
          //QDP_math_time -= QDP_time();
          QLA_F3_D_vmeq_sprecon_M_times_pH( dest[i]->data+subset->offset+offset, src1[i]->data+subset->offset+offset, src2[i]->ptr+subset->offset+offset, dir[i], sign[i], blen );
          //QDP_math_time += QDP_time();
        } else {
          //QDP_math_time -= QDP_time();
          QLA_F3_D_vmeq_sprecon_M_times_H( dest[i]->data+subset->offset+offset, src1[i]->data+subset->offset+offset, src2[i]->data+subset->offset+offset, dir[i], sign[i], blen );
          //QDP_math_time += QDP_time();
        }
      }
    }
    }
    offset += blen;
  }
}
