/*
 *  Binary operations with constants
 *
 *  Multiplication by real constant
 */

#include "qdp_f3_internal.h"

void
QDP_F3_M_meq_r_times_M( QDP_F3_ColorMatrix *__restrict__ dest, QLA_F_Real *src1, QDP_F3_ColorMatrix *src2, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src2->dc);

  if( subset->indexed ) {
    if( src2->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_F3_M_xmeq_r_times_pM( dest->data, src1, src2->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_F3_M_xmeq_r_times_M( dest->data, src1, src2->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src2->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_F3_M_vmeq_r_times_pM( dest->data+subset->offset, src1, src2->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_F3_M_vmeq_r_times_M( dest->data+subset->offset, src1, src2->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
