/*
 *  Binary operations with constants
 *
 *  Left multiplication by gamma matrix
 */

#include "qdp_f3_internal.h"

void
QDP_F3_P_eq_gamma_times_P( QDP_F3_DiracPropagator *__restrict__ dest, QDP_F3_DiracPropagator *src, int i, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_F3_P_xeq_gamma_times_pP( dest->data, src->ptr, i, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_F3_P_xeq_gamma_times_P( dest->data, src->data, i, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_F3_P_veq_gamma_times_pP( dest->data+subset->offset, src->ptr+subset->offset, i, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_F3_P_veq_gamma_times_P( dest->data+subset->offset, src->data+subset->offset, i, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
