/*
 *  Type conversion and component extraction and insertion
 *
 *  Extracting a color vector from a half fermion or Dirac fermion
 */

#include "qdp_f3_internal.h"

void
QDP_F3_V_eq_colorvec_H( QDP_F3_ColorVector *__restrict__ dest, QDP_F3_HalfFermion *src, int spin, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_F3_V_xeq_colorvec_pH( dest->data, src->ptr, spin, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_F3_V_xeq_colorvec_H( dest->data, src->data, spin, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_F3_V_veq_colorvec_pH( dest->data+subset->offset, src->ptr+subset->offset, spin, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_F3_V_veq_colorvec_H( dest->data+subset->offset, src->data+subset->offset, spin, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
