/*
 *  Type conversion and component extraction and insertion
 *
 *  Extracting a color vector from a color matrix column
 */

#include "qdp_f3_internal.h"

void
QDP_F3_V_eq_colorvec_M( QDP_F3_ColorVector *__restrict__ dest, QDP_F3_ColorMatrix *src, int j, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_F3_V_xeq_colorvec_pM( dest->data, src->ptr, j, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_F3_V_xeq_colorvec_M( dest->data, src->data, j, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_F3_V_veq_colorvec_pM( dest->data+subset->offset, src->ptr+subset->offset, j, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_F3_V_veq_colorvec_M( dest->data+subset->offset, src->data+subset->offset, j, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
