/*
 *  Type conversion and component extraction and insertion
 *
 *  Inserting a color vector element
 */

#include "qdp_f3_internal.h"

void
QDP_F3_V_eq_elem_C( QDP_F3_ColorVector *__restrict__ dest, QDP_F_Complex *src, int i, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_F3_V_xeq_elem_pC( dest->data, src->ptr, i, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_F3_V_xeq_elem_C( dest->data, src->data, i, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_F3_V_veq_elem_pC( dest->data+subset->offset, src->ptr+subset->offset, i, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_F3_V_veq_elem_C( dest->data+subset->offset, src->data+subset->offset, i, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
