/*
 *  Reductions
 *
 *  Global inner product
 */

#include "qdp_f3_internal.h"

void
QDP_F3_c_eq_D_dot_D( QLA_F_Complex *__restrict__ dest, QDP_F3_DiracFermion *src1, QDP_F3_DiracFermion *src2, QDP_Subset subset )
{
  QLA_D_Complex dtemp;
  QDP_prepare_src(&src1->dc);
  QDP_prepare_src(&src2->dc);

  if( subset->indexed ) {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_xeq_pD_dot_pD( &dtemp, src1->ptr, src2->ptr, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_xeq_pD_dot_D( &dtemp, src1->ptr, src2->data, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_xeq_D_dot_pD( &dtemp, src1->data, src2->ptr, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_xeq_D_dot_D( &dtemp, src1->data, src2->data, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      }
    }
  } else {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_veq_pD_dot_pD( &dtemp, src1->ptr+subset->offset, src2->ptr+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_veq_pD_dot_D( &dtemp, src1->ptr+subset->offset, src2->data+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_veq_D_dot_pD( &dtemp, src1->data+subset->offset, src2->ptr+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_veq_D_dot_D( &dtemp, src1->data+subset->offset, src2->data+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      }
    }
  }
  QDP_binary_reduce(QLA_D_C_peq_C, sizeof(QLA_D_Complex), &dtemp);
  QLA_FD_C_eq_C(dest, &dtemp);
}
