/*
 *  Reductions
 *
 *  Multisubset inner products
 */

#include "qdp_f3_internal.h"

void
QDP_F3_c_eq_H_dot_H_multi( QLA_F_Complex dest[], QDP_F3_HalfFermion *src1, QDP_F3_HalfFermion *src2, QDP_Subset subset[], int ns )
{
  int i;
  QLA_D_Complex *dtemp;
  dtemp = (QLA_D_Complex *) malloc(ns*sizeof(QLA_D_Complex));
  QDP_prepare_src(&src1->dc);
  QDP_prepare_src(&src2->dc);

  for(i=0; i<ns; i++) {
  if( subset[i]->indexed ) {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_xeq_pH_dot_pH( &dtemp[i], src1->ptr, src2->ptr, subset[i]->index, subset[i]->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_xeq_pH_dot_H( &dtemp[i], src1->ptr, src2->data, subset[i]->index, subset[i]->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_xeq_H_dot_pH( &dtemp[i], src1->data, src2->ptr, subset[i]->index, subset[i]->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_xeq_H_dot_H( &dtemp[i], src1->data, src2->data, subset[i]->index, subset[i]->len );
        //QDP_math_time += QDP_time();
      }
    }
  } else {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_veq_pH_dot_pH( &dtemp[i], src1->ptr+subset[i]->offset, src2->ptr+subset[i]->offset, subset[i]->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_veq_pH_dot_H( &dtemp[i], src1->ptr+subset[i]->offset, src2->data+subset[i]->offset, subset[i]->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_veq_H_dot_pH( &dtemp[i], src1->data+subset[i]->offset, src2->ptr+subset[i]->offset, subset[i]->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_c_veq_H_dot_H( &dtemp[i], src1->data+subset[i]->offset, src2->data+subset[i]->offset, subset[i]->len );
        //QDP_math_time += QDP_time();
      }
    }
  }
  }
  QDP_binary_reduce_multi(QLA_D_C_vpeq_C, sizeof(QLA_D_Complex), dtemp, ns);
  QLA_FD_C_veq_C(dest, dtemp, ns);
  free(dtemp);
}
