/*
 *  Reductions
 *
 *  Global sums
 */

#include "qdp_f3_internal.h"

void
QDP_F3_d_eq_sum_D( QLA_F3_DiracFermion *__restrict__ dest, QDP_F3_DiracFermion *src, QDP_Subset subset )
{
  QLA_D3_DiracFermion dtemp;
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_d_xeq_sum_pD( &dtemp, src->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_d_xeq_sum_D( &dtemp, src->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_d_veq_sum_pD( &dtemp, src->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_d_veq_sum_D( &dtemp, src->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
  QDP_binary_reduce(QLA_D3_D_peq_D, sizeof(QLA_D3_DiracFermion), &dtemp);
  QLA_FD3_D_eq_D(dest, &dtemp);
}
