/*
 *  Reductions
 *
 *  Multisubset global sums
 */

#include "qdp_f3_internal.h"

void
QDP_F3_d_eq_sum_D_multi( QLA_F3_DiracFermion dest[], QDP_F3_DiracFermion *src, QDP_Subset subset[], int ns )
{
  int i;
  QLA_D3_DiracFermion *dtemp;
  dtemp = (QLA_D3_DiracFermion *) malloc(ns*sizeof(QLA_D3_DiracFermion));
  QDP_prepare_src(&src->dc);

  for(i=0; i<ns; i++) {
  if( subset[i]->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_d_xeq_sum_pD( &dtemp[i], src->ptr, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_d_xeq_sum_D( &dtemp[i], src->data, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_d_veq_sum_pD( &dtemp[i], src->ptr+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_d_veq_sum_D( &dtemp[i], src->data+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  }
  }
  QDP_binary_reduce_multi(QLA_D3_D_vpeq_D, sizeof(QLA_D3_DiracFermion), dtemp, ns);
  QLA_FD3_D_veq_D(dest, dtemp, ns);
  free(dtemp);
}
