/*
 *  Reductions
 *
 *  Multisubset global sums
 */

#include "qdp_f3_internal.h"

void
QDP_F3_h_eq_sum_H_multi( QLA_F3_HalfFermion dest[], QDP_F3_HalfFermion *src, QDP_Subset subset[], int ns )
{
  int i;
  QLA_D3_HalfFermion *dtemp;
  dtemp = (QLA_D3_HalfFermion *) malloc(ns*sizeof(QLA_D3_HalfFermion));
  QDP_prepare_src(&src->dc);

  for(i=0; i<ns; i++) {
  if( subset[i]->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_h_xeq_sum_pH( &dtemp[i], src->ptr, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_h_xeq_sum_H( &dtemp[i], src->data, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_h_veq_sum_pH( &dtemp[i], src->ptr+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_h_veq_sum_H( &dtemp[i], src->data+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  }
  }
  QDP_binary_reduce_multi(QLA_D3_H_vpeq_H, sizeof(QLA_D3_HalfFermion), dtemp, ns);
  QLA_FD3_H_veq_H(dest, dtemp, ns);
  free(dtemp);
}
