/*
 *  Reductions
 *
 *  Global sums
 */

#include "qdp_f3_internal.h"

void
QDP_F3_m_eq_sum_M( QLA_F3_ColorMatrix *__restrict__ dest, QDP_F3_ColorMatrix *src, QDP_Subset subset )
{
  QLA_D3_ColorMatrix dtemp;
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_m_xeq_sum_pM( &dtemp, src->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_m_xeq_sum_M( &dtemp, src->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_m_veq_sum_pM( &dtemp, src->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_m_veq_sum_M( &dtemp, src->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
  QDP_binary_reduce(QLA_D3_M_peq_M, sizeof(QLA_D3_ColorMatrix), &dtemp);
  QLA_FD3_M_eq_M(dest, &dtemp);
}
