/*
 *  Reductions
 *
 *  Global sums
 */

#include "qdp_f3_internal.h"

void
QDP_F3_p_eq_sum_P( QLA_F3_DiracPropagator *__restrict__ dest, QDP_F3_DiracPropagator *src, QDP_Subset subset )
{
  QLA_D3_DiracPropagator dtemp;
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_p_xeq_sum_pP( &dtemp, src->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_p_xeq_sum_P( &dtemp, src->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_p_veq_sum_pP( &dtemp, src->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_p_veq_sum_P( &dtemp, src->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
  QDP_binary_reduce(QLA_D3_P_peq_P, sizeof(QLA_D3_DiracPropagator), &dtemp);
  QLA_FD3_P_eq_P(dest, &dtemp);
}
