/*
 *  Reductions
 *
 *  Multisubset global sums
 */

#include "qdp_f3_internal.h"

void
QDP_F3_p_eq_sum_P_multi( QLA_F3_DiracPropagator dest[], QDP_F3_DiracPropagator *src, QDP_Subset subset[], int ns )
{
  int i;
  QLA_D3_DiracPropagator *dtemp;
  dtemp = (QLA_D3_DiracPropagator *) malloc(ns*sizeof(QLA_D3_DiracPropagator));
  QDP_prepare_src(&src->dc);

  for(i=0; i<ns; i++) {
  if( subset[i]->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_p_xeq_sum_pP( &dtemp[i], src->ptr, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_p_xeq_sum_P( &dtemp[i], src->data, subset[i]->index, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_p_veq_sum_pP( &dtemp[i], src->ptr+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_p_veq_sum_P( &dtemp[i], src->data+subset[i]->offset, subset[i]->len );
      //QDP_math_time += QDP_time();
    }
  }
  }
  QDP_binary_reduce_multi(QLA_D3_P_vpeq_P, sizeof(QLA_D3_DiracPropagator), dtemp, ns);
  QLA_FD3_P_veq_P(dest, dtemp, ns);
  free(dtemp);
}
