/*
 *  Reductions
 *
 *  Global squared norm: uniform precision
 */

#include "qdp_f3_internal.h"

void
QDP_F3_r_eq_norm2_V( QLA_F_Real *__restrict__ dest, QDP_F3_ColorVector *src, QDP_Subset subset )
{
  QLA_D_Real dtemp;
  QDP_prepare_src(&src->dc);

  if( subset->indexed ) {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_r_xeq_norm2_pV( &dtemp, src->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_r_xeq_norm2_V( &dtemp, src->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_DF3_r_veq_norm2_pV( &dtemp, src->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_DF3_r_veq_norm2_V( &dtemp, src->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
  QDP_binary_reduce(QLA_D_R_peq_R, sizeof(QLA_D_Real), &dtemp);
  QLA_FD_R_eq_R(dest, &dtemp);
}
