/*
 *  Reductions
 *
 *  Real part of global inner product
 */

#include "qdp_f3_internal.h"

void
QDP_F3_r_eq_re_H_dot_H( QLA_F_Real *__restrict__ dest, QDP_F3_HalfFermion *src1, QDP_F3_HalfFermion *src2, QDP_Subset subset )
{
  QLA_D_Real dtemp;
  QDP_prepare_src(&src1->dc);
  QDP_prepare_src(&src2->dc);

  if( subset->indexed ) {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_r_xeq_re_pH_dot_pH( &dtemp, src1->ptr, src2->ptr, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_r_xeq_re_pH_dot_H( &dtemp, src1->ptr, src2->data, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_r_xeq_re_H_dot_pH( &dtemp, src1->data, src2->ptr, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_r_xeq_re_H_dot_H( &dtemp, src1->data, src2->data, subset->index, subset->len );
        //QDP_math_time += QDP_time();
      }
    }
  } else {
    if( src1->ptr ) {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_r_veq_re_pH_dot_pH( &dtemp, src1->ptr+subset->offset, src2->ptr+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_r_veq_re_pH_dot_H( &dtemp, src1->ptr+subset->offset, src2->data+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src2->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_r_veq_re_H_dot_pH( &dtemp, src1->data+subset->offset, src2->ptr+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_r_veq_re_H_dot_H( &dtemp, src1->data+subset->offset, src2->data+subset->offset, subset->len );
        //QDP_math_time += QDP_time();
      }
    }
  }
  QDP_binary_reduce(QLA_D_R_peq_R, sizeof(QLA_D_Real), &dtemp);
  QLA_FD_R_eq_R(dest, &dtemp);
}
