/*
 *  Reductions
 *
 *  Global squared norm: uniform precision
 */

#include "qdp_f3_internal.h"

void
QDP_F3_r_veq_norm2_M( QLA_F_Real dest[], QDP_F3_ColorMatrix *src[], QDP_Subset subset, int nv )
{
  int i, offset, blen;
  QLA_D_Real *dtemp;
  dtemp = (QLA_D_Real *) malloc(nv*sizeof(QLA_D_Real));
  QLA_D_R_veq_zero(dtemp, nv);
  for(i=0; i<nv; ++i) {
    QDP_prepare_src(&src[i]->dc);
  }

  offset = 0;
  blen = QDP_block_size;
  while(1) {
    if( blen > subset->len - offset ) blen = subset->len - offset;
    if( blen <= 0) break;
    for(i=0; i<nv; ++i) {
    if( subset->indexed ) {
      if( src[i]->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_r_xpeq_norm2_pM( &dtemp[i], src[i]->ptr, subset->index+offset, blen );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_r_xpeq_norm2_M( &dtemp[i], src[i]->data, subset->index+offset, blen );
        //QDP_math_time += QDP_time();
      }
    } else {
      if( src[i]->ptr ) {
        //QDP_math_time -= QDP_time();
        QLA_DF3_r_vpeq_norm2_pM( &dtemp[i], src[i]->ptr+subset->offset+offset, blen );
        //QDP_math_time += QDP_time();
      } else {
        //QDP_math_time -= QDP_time();
        QLA_DF3_r_vpeq_norm2_M( &dtemp[i], src[i]->data+subset->offset+offset, blen );
        //QDP_math_time += QDP_time();
      }
    }
    }
    offset += blen;
  }
  QDP_binary_reduce_multi(QLA_D_R_vpeq_R, sizeof(QLA_D_Real), dtemp, nv);
  QLA_FD_R_veq_R(dest, dtemp, nv);
  free(dtemp);
}
