#include <stdlib.h>
#include "qdp_f3_internal.h"
#include <qdp_string.h>

#undef N
#define N -1
#if (3+0) == -1
#define NC qf->nc,
#else
#define NC
#endif
#undef N

#undef F
#undef D
#define F -1
#define D -1
#if (F+0) == -1
#define WS QDPIO_word_H(F)
#else
#define WS QDPIO_word_H(dummy)
#endif
#undef F
#undef D

/* Internal factory function for array of field data */
static void
QDP_F3_vput_H(char *buf, size_t index, int count, void *qfin)
{
  struct QDP_IO_field *qf = qfin;
  QDP_F3_HalfFermion **field = (QDP_F3_HalfFermion **)(qf->data);
  QLA_F3_HalfFermion *dest;
  QLA_F3_HalfFermion *src = (QLA_F3_HalfFermion *)buf;
  int i;

/* For the site specified by "index", move an array of "count" data
   from the read buffer to an array of fields */

  for(i=0; i<count; i++) {
    dest = QDP_F3_expose_H( field[i] ) + index;
    QDPIO_put_H(NC, F, _F3, dest, src+i, qf->nc, QLA_Ns);
    QDP_F3_reset_H( field[i] );
  }
}

/* Internal factory function for global data */
static void
QDP_F3_vput_h(char *buf, size_t index, int count, void *qfin)
{
  struct QDP_IO_field *qf = qfin;
  QLA_F3_HalfFermion *dest = (QLA_F3_HalfFermion *)(qf->data);
  QLA_F3_HalfFermion *src = (QLA_F3_HalfFermion *)buf;
  int i;

  for(i=0; i<count; i++) {
    QDPIO_put_H(NC, F, _F3, (dest+i), (src+i), qf->nc, QLA_Ns);
  }
}

/* read an array of QDP fields */
int
QDP_F3_vread_H( QDP_Reader *qdpr, QDP_String *md, QDP_F3_HalfFermion *field[],
		   int nv)
{
  struct QDP_IO_field qf;
  int i, status;
  QIO_RecordInfo *cmp_info;

  qf.data = (char *) field;
  qf.size = QDPIO_size_H(F, 3, QLA_Ns);
  qf.nc = 3;
  qf.word_size = WS;

  cmp_info = QIO_create_record_info(QIO_FIELD, "QDP_F3_HalfFermion", "F", 3,
				    QLA_Ns, qf.size, nv);

  for(i=0; i<nv; i++) QDP_prepare_dest( &field[i]->dc );

  status = QDP_read_check(qdpr, md, QIO_FIELD, QDP_F3_vput_H, &qf,
			  nv, cmp_info);

  QIO_destroy_record_info(cmp_info);

  return status;
}

/* read a single QDP field */
int
QDP_F3_read_H( QDP_Reader *qdpr, QDP_String *md, QDP_F3_HalfFermion *field)
{
  QDP_F3_HalfFermion *temp[1];
  temp[0] = field;
  return QDP_F3_vread_H(qdpr, md, temp, 1);
}

/* read a global array of QLA data */
int
QDP_F3_vread_h( QDP_Reader *qdpr, QDP_String *md, QLA_F3_HalfFermion *array,
		      int n)
{
  struct QDP_IO_field qf;
  int status;
  QIO_RecordInfo *cmp_info;

  qf.data = (char *) array;
  qf.size = QDPIO_size_H(F, 3, QLA_Ns);
  qf.nc   = 3;
  qf.word_size = WS;

  cmp_info = QIO_create_record_info(QIO_GLOBAL, "QDP_F3_HalfFermion", "F", 3,
				    QLA_Ns, qf.size, n);

  status = QDP_read_check(qdpr, md, QIO_GLOBAL, QDP_F3_vput_h, &qf,
			  n, cmp_info);

  QIO_destroy_record_info(cmp_info);

  return status;
}
