#include <stdlib.h>
#include "qdp_f3_internal.h"
#include <qdp_string.h>

#undef N
#define N -1
#if (3+0) == -1
#define NC qf->nc,
#else
#define NC
#endif

#undef F
#undef D
#define F -1
#define D -1
#if (F+0) == -1
#define WS QDPIO_word_H(F)
#else
#define WS QDPIO_word_H(dummy)
#endif
#undef F
#undef D

/* Internal factory function for array of field data */
static void
QDP_F3_vget_H(char *buf, size_t index, int count, void *qfin)
{
  struct QDP_IO_field *qf = qfin;
  QDP_F3_HalfFermion **field = (QDP_F3_HalfFermion **)(qf->data);
  QLA_F3_HalfFermion *src;
  QLA_F3_HalfFermion *dest = (QLA_F3_HalfFermion *)buf;
  int i;

/* For the site specified by "index", move an array of "count" data
   from the array of fields to the write buffer */
  for(i = 0; i < count; i++, dest++) {
    src = QDP_F3_expose_H( field[i] ) + index;
    QDPIO_get_H(NC, F, _F3, dest, src, qf->nc, QLA_Ns);
    QDP_F3_reset_H( field[i] );
  }
}

/* Internal factory function for global data */
static void
QDP_F3_vget_h(char *buf, size_t index, int count, void *qfin)
{
  struct QDP_IO_field *qf = qfin;
  QLA_F3_HalfFermion *src = (QLA_F3_HalfFermion *)(qf->data);
  QLA_F3_HalfFermion *dest = (QLA_F3_HalfFermion *)buf;
  int i;

  for(i = 0; i < count; i++, src++, dest++)
    QDPIO_get_H(NC, F, _F3, dest, src, qf->nc, QLA_Ns);
}

/* Write an array of QDP fields */
int
QDP_F3_vwrite_H(QDP_Writer *qdpw, QDP_String *md, QDP_F3_HalfFermion *field[],
		    int nv)
{
  struct QDP_IO_field qf;
  int i, status;
  QIO_RecordInfo *rec_info;

  qf.data = (char *) field;
  qf.size = QDPIO_size_H(F, 3, QLA_Ns);
  qf.nc = 3;
  qf.word_size = WS;

  rec_info = QIO_create_record_info(QIO_FIELD, "QDP_F3_HalfFermion", "F", 3,
				    QLA_Ns, qf.size, nv);

  for(i=0; i<nv; i++)
    QDP_prepare_dest( &field[i]->dc );

  status = QDP_write_check(qdpw, md, QIO_FIELD, QDP_F3_vget_H, &qf, nv,
			   rec_info);
  return status;
}

/* Write a single QDP field */
int
QDP_F3_write_H( QDP_Writer *qdpw, QDP_String *md, QDP_F3_HalfFermion *f)
{
  QDP_F3_HalfFermion *field[1];
  field[0] = f;
  return QDP_F3_vwrite_H(qdpw, md, field, 1);
}

/* Write a global array of QLA data */
int
QDP_F3_vwrite_h(QDP_Writer *qdpw, QDP_String *md, QLA_F3_HalfFermion *array,
		       int count)
{
  struct QDP_IO_field qf;
  QIO_RecordInfo *rec_info;

  qf.data = (char *) array;
  qf.size = QDPIO_size_H(F, 3, QLA_Ns);
  qf.nc = 3;
  qf.word_size = WS;

  rec_info = QIO_create_record_info(QIO_GLOBAL, "QDP_F3_HalfFermion", "F", 3,
				    QLA_Ns, qf.size, count);

  return QDP_write_check(qdpw, md, QIO_GLOBAL, QDP_F3_vget_h,
			 &qf, count, rec_info);
}
