/*
 *  Binary operations with constants
 *
 *  Multiplication by integer constant
 */

#include "qdp_int_internal.h"

void
QDP_I_peq_i_times_I( QDP_Int *__restrict__ dest, QLA_Int *src1, QDP_Int *src2, QDP_Subset subset )
{
  QDP_prepare_dest(&dest->dc);
  QDP_prepare_src(&src2->dc);

  if( subset->indexed ) {
    if( src2->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_I_xpeq_i_times_pI( dest->data, src1, src2->ptr, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_I_xpeq_i_times_I( dest->data, src1, src2->data, subset->index, subset->len );
      //QDP_math_time += QDP_time();
    }
  } else {
    if( src2->ptr ) {
      //QDP_math_time -= QDP_time();
      QLA_I_vpeq_i_times_pI( dest->data+subset->offset, src1, src2->ptr+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    } else {
      //QDP_math_time -= QDP_time();
      QLA_I_vpeq_i_times_I( dest->data+subset->offset, src1, src2->data+subset->offset, subset->len );
      //QDP_math_time += QDP_time();
    }
  }
}
