#include <stdlib.h>
#include "qdp_int_internal.h"
#include <qdp_string.h>

#undef N
#define N -1
#if (+0) == -1
#define NC qf->nc,
#else
#define NC
#endif
#undef N

#undef F
#undef D
#define F -1
#define D -1
#if (+0) == -1
#define WS QDPIO_word_I()
#else
#define WS QDPIO_word_I(dummy)
#endif
#undef F
#undef D

/* Internal factory function for array of field data */
static void
QDP_vput_I(char *buf, size_t index, int count, void *qfin)
{
  struct QDP_IO_field *qf = qfin;
  QDP_Int **field = (QDP_Int **)(qf->data);
  QLA_Int *dest;
  QLA_Int *src = (QLA_Int *)buf;
  int i;

/* For the site specified by "index", move an array of "count" data
   from the read buffer to an array of fields */

  for(i=0; i<count; i++) {
    dest = QDP_expose_I( field[i] ) + index;
    QDPIO_put_I(NC, , , dest, src+i, qf->nc, QLA_Ns);
    QDP_reset_I( field[i] );
  }
}

/* Internal factory function for global data */
static void
QDP_vput_i(char *buf, size_t index, int count, void *qfin)
{
  struct QDP_IO_field *qf = qfin;
  QLA_Int *dest = (QLA_Int *)(qf->data);
  QLA_Int *src = (QLA_Int *)buf;
  int i;

  for(i=0; i<count; i++) {
    QDPIO_put_I(NC, , , (dest+i), (src+i), qf->nc, QLA_Ns);
  }
}

/* read an array of QDP fields */
int
QDP_vread_I( QDP_Reader *qdpr, QDP_String *md, QDP_Int *field[],
		   int nv)
{
  struct QDP_IO_field qf;
  int i, status;
  QIO_RecordInfo *cmp_info;

  qf.data = (char *) field;
  qf.size = QDPIO_size_I(, 0, QLA_Ns);
  qf.nc = 0;
  qf.word_size = WS;

  cmp_info = QIO_create_record_info(QIO_FIELD, "QDP_Int", "", 0,
				    QLA_Ns, qf.size, nv);

  for(i=0; i<nv; i++) QDP_prepare_dest( &field[i]->dc );

  status = QDP_read_check(qdpr, md, QIO_FIELD, QDP_vput_I, &qf,
			  nv, cmp_info);

  QIO_destroy_record_info(cmp_info);

  return status;
}

/* read a single QDP field */
int
QDP_read_I( QDP_Reader *qdpr, QDP_String *md, QDP_Int *field)
{
  QDP_Int *temp[1];
  temp[0] = field;
  return QDP_vread_I(qdpr, md, temp, 1);
}

/* read a global array of QLA data */
int
QDP_vread_i( QDP_Reader *qdpr, QDP_String *md, QLA_Int *array,
		      int n)
{
  struct QDP_IO_field qf;
  int status;
  QIO_RecordInfo *cmp_info;

  qf.data = (char *) array;
  qf.size = QDPIO_size_I(, 0, QLA_Ns);
  qf.nc   = 0;
  qf.word_size = WS;

  cmp_info = QIO_create_record_info(QIO_GLOBAL, "QDP_Int", "", 0,
				    QLA_Ns, qf.size, n);

  status = QDP_read_check(qdpr, md, QIO_GLOBAL, QDP_vput_i, &qf,
			  n, cmp_info);

  QIO_destroy_record_info(cmp_info);

  return status;
}
