/* QDP profiling header for D */

#ifndef _QDP_D_PROFILE_H
#define _QDP_D_PROFILE_H
#define QDP_D_R_eq_func(_dest, _func, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_func"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_func(_dest, _func, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_func(_dest, _func, _subset); \
  } \
}
#define QDP_D_C_eq_func(_dest, _func, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_func"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_func(_dest, _func, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_func(_dest, _func, _subset); \
  } \
}
#define QDP_D_R_eq_sR(_dest, _src, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_D_R_eq_sR(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_D_R_eq_sR(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_D_R_eq_sR(_dest, _src, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_D_R_eq_sR(_dest, _src, _shift, _fb, _subset); \
  } \
}
#define QDP_D_R_veq_sR(_dest, _src, _shift, _fb, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_D_R_veq_sR(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_D_R_veq_sR(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_D_R_veq_sR(_dest, _src, _shift, _fb, _subset, _nv); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += _nv*QDP_subset_len(_subset); \
  } else { \
    QDP_D_R_veq_sR(_dest, _src, _shift, _fb, _subset, _nv); \
  } \
}
#define QDP_D_C_eq_sC(_dest, _src, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_D_C_eq_sC(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_D_C_eq_sC(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_D_C_eq_sC(_dest, _src, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_D_C_eq_sC(_dest, _src, _shift, _fb, _subset); \
  } \
}
#define QDP_D_C_veq_sC(_dest, _src, _shift, _fb, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_D_C_veq_sC(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_D_C_veq_sC(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_D_C_veq_sC(_dest, _src, _shift, _fb, _subset, _nv); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += _nv*QDP_subset_len(_subset); \
  } else { \
    QDP_D_C_veq_sC(_dest, _src, _shift, _fb, _subset, _nv); \
  } \
}
#define QDP_D_R_eq_zero(_dest, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_zero"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_zero(_dest, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_zero(_dest, _subset); \
  } \
}
#define QDP_D_C_eq_zero(_dest, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_zero"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_zero(_dest, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_zero(_dest, _subset); \
  } \
}
#define QDP_D_R_eq_r(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_r"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_r(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_r(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eq_c(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_c"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_c(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_c(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_random_S(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_random_S"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_random_S(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_random_S(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_gaussian_S(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_gaussian_S"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_gaussian_S(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_gaussian_S(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eq_gaussian_S(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_gaussian_S"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_gaussian_S(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_gaussian_S(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_sin_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_sin_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_sin_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_sin_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_cos_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_cos_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_cos_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_cos_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_tan_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_tan_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_tan_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_tan_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_asin_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_asin_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_asin_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_asin_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_acos_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_acos_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_acos_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_acos_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_atan_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_atan_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_atan_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_atan_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_sqrt_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_sqrt_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_sqrt_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_sqrt_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_fabs_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_fabs_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_fabs_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_fabs_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_exp_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_exp_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_exp_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_exp_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_log_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_log_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_log_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_log_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_sign_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_sign_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_sign_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_sign_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_ceil_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_ceil_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_ceil_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_ceil_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_floor_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_floor_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_floor_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_floor_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_sinh_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_sinh_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_sinh_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_sinh_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_cosh_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_cosh_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_cosh_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_cosh_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_tanh_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_tanh_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_tanh_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_tanh_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_log10_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_log10_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_log10_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_log10_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eq_cexpi_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_cexpi_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_cexpi_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_cexpi_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_norm_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_norm_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_norm_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_norm_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_arg_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_arg_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_arg_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_arg_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eq_cexp_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_cexp_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_cexp_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_cexp_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eq_csqrt_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_csqrt_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_csqrt_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_csqrt_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eq_clog_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_clog_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_clog_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_clog_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eq_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_veq_R(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_veq_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_veq_R(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_veq_R(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_D_C_veq_C(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_veq_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_veq_C(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_veq_C(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_D_R_eqm_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eqm_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eqm_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eqm_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eqm_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eqm_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eqm_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eqm_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_peq_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_peq_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_peq_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_peq_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_peq_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_peq_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_peq_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_peq_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_meq_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_meq_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_meq_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_meq_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_meq_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_meq_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_meq_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_meq_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_veqm_R(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_veqm_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_veqm_R(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_veqm_R(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_D_C_veqm_C(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_veqm_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_veqm_C(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_veqm_C(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_D_R_vpeq_R(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_vpeq_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_vpeq_R(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_vpeq_R(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_D_C_vpeq_C(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_vpeq_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_vpeq_C(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_vpeq_C(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_D_R_vmeq_R(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_vmeq_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_vmeq_R(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_vmeq_R(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_D_C_vmeq_C(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_vmeq_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_vmeq_C(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_vmeq_C(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_D_C_eq_conj_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_conj_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_conj_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_conj_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_peq_conj_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_peq_conj_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_peq_conj_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_peq_conj_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_meq_conj_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_meq_conj_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_meq_conj_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_meq_conj_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eqm_conj_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eqm_conj_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eqm_conj_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eqm_conj_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eq_Ca(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_Ca"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_Ca(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_Ca(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_peq_Ca(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_peq_Ca"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_peq_Ca(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_peq_Ca(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_meq_Ca(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_meq_Ca"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_meq_Ca(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_meq_Ca(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eqm_Ca(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eqm_Ca"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eqm_Ca(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eqm_Ca(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_norm2_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_norm2_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_norm2_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_norm2_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eq_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eq_R_plus_i_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_R_plus_i_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_R_plus_i_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_R_plus_i_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_re_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_re_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_re_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_re_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_im_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_im_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_im_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_im_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_I(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_I(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_I(_dest, _src, _subset); \
  } \
}
#define QDP_D_I_eq_trunc_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_I_eq_trunc_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_I_eq_trunc_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_I_eq_trunc_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_I_eq_round_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_I_eq_round_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_I_eq_round_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_I_eq_round_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_r_times_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_r_times_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_r_times_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_r_times_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eq_r_times_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_r_times_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_r_times_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_r_times_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_peq_r_times_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_peq_r_times_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_peq_r_times_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_peq_r_times_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_peq_r_times_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_peq_r_times_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_peq_r_times_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_peq_r_times_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_meq_r_times_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_meq_r_times_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_meq_r_times_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_meq_r_times_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_meq_r_times_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_meq_r_times_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_meq_r_times_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_meq_r_times_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eqm_r_times_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eqm_r_times_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eqm_r_times_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eqm_r_times_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eqm_r_times_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eqm_r_times_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eqm_r_times_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eqm_r_times_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eq_c_times_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_c_times_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_c_times_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_c_times_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_peq_c_times_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_peq_c_times_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_peq_c_times_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_peq_c_times_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_meq_c_times_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_meq_c_times_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_meq_c_times_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_meq_c_times_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eqm_c_times_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eqm_c_times_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eqm_c_times_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eqm_c_times_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eq_i_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_i_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_i_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_i_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_peq_i_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_peq_i_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_peq_i_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_peq_i_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_meq_i_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_meq_i_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_meq_i_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_meq_i_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_C_eqm_i_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eqm_i_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eqm_i_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eqm_i_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_R_eq_R_mod_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_R_mod_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_R_mod_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_R_mod_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_R_max_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_R_max_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_R_max_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_R_max_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_R_min_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_R_min_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_R_min_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_R_min_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_R_pow_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_R_pow_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_R_pow_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_R_pow_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_R_atan2_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_R_atan2_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_R_atan2_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_R_atan2_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_R_ldexp_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_R_ldexp_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_R_ldexp_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_R_ldexp_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_R_plus_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_R_plus_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_R_plus_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_R_plus_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eq_C_plus_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_C_plus_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_C_plus_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_C_plus_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_R_minus_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_R_minus_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_R_minus_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_R_minus_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eq_C_minus_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_C_minus_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_C_minus_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_C_minus_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_R_times_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_R_times_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_R_times_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_R_times_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eq_C_times_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_C_times_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_C_times_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_C_times_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_peq_R_times_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_peq_R_times_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_peq_R_times_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_peq_R_times_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_peq_C_times_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_peq_C_times_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_peq_C_times_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_peq_C_times_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_meq_R_times_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_meq_R_times_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_meq_R_times_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_meq_R_times_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_meq_C_times_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_meq_C_times_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_meq_C_times_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_meq_C_times_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eqm_R_times_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eqm_R_times_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eqm_R_times_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eqm_R_times_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eqm_C_times_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eqm_C_times_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eqm_C_times_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eqm_C_times_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_R_divide_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_R_divide_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_R_divide_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_R_divide_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eq_C_divide_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_C_divide_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_C_divide_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_C_divide_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eq_C_dot_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_C_dot_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_C_dot_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_C_dot_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_re_C_dot_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_re_C_dot_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_re_C_dot_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_re_C_dot_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_r_times_R_plus_R(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_r_times_R_plus_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_r_times_R_plus_R(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_r_times_R_plus_R(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eq_r_times_C_plus_C(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_r_times_C_plus_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_r_times_C_plus_C(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_r_times_C_plus_C(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_r_times_R_minus_R(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_r_times_R_minus_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_r_times_R_minus_R(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_r_times_R_minus_R(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eq_r_times_C_minus_C(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_r_times_C_minus_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_r_times_C_minus_C(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_r_times_C_minus_C(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eq_c_times_C_plus_C(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_c_times_C_plus_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_c_times_C_plus_C(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_c_times_C_plus_C(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eq_c_times_C_minus_C(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_c_times_C_minus_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_c_times_C_minus_C(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_c_times_C_minus_C(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_D_I_eq_R_eq_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_I_eq_R_eq_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_I_eq_R_eq_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_I_eq_R_eq_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_I_eq_R_ne_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_I_eq_R_ne_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_I_eq_R_ne_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_I_eq_R_ne_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_I_eq_R_gt_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_I_eq_R_gt_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_I_eq_R_gt_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_I_eq_R_gt_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_I_eq_R_lt_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_I_eq_R_lt_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_I_eq_R_lt_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_I_eq_R_lt_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_I_eq_R_ge_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_I_eq_R_ge_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_I_eq_R_ge_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_I_eq_R_ge_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_I_eq_R_le_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_I_eq_R_le_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_I_eq_R_le_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_I_eq_R_le_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_R_eq_R_mask_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_R_eq_R_mask_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_R_eq_R_mask_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_R_eq_R_mask_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_C_eq_C_mask_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_C_eq_C_mask_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_C_eq_C_mask_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_C_eq_C_mask_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_r_eq_norm2_I(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_norm2_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_norm2_I(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_norm2_I(_dest, _src, _subset); \
  } \
}
#define QDP_D_r_eq_norm2_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_norm2_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_norm2_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_norm2_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_r_eq_norm2_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_norm2_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_norm2_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_norm2_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_r_veq_norm2_I(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_veq_norm2_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_veq_norm2_I(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_veq_norm2_I(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_D_r_veq_norm2_R(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_veq_norm2_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_veq_norm2_R(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_veq_norm2_R(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_D_r_veq_norm2_C(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_veq_norm2_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_veq_norm2_C(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_veq_norm2_C(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_D_r_eq_I_dot_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_I_dot_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_I_dot_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_I_dot_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_r_eq_R_dot_R(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_R_dot_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_R_dot_R(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_R_dot_R(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_r_veq_I_dot_I(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_veq_I_dot_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_veq_I_dot_I(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_veq_I_dot_I(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_D_r_veq_R_dot_R(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_veq_R_dot_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_veq_R_dot_R(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_veq_R_dot_R(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_D_c_eq_C_dot_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_c_eq_C_dot_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_c_eq_C_dot_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_c_eq_C_dot_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_c_veq_C_dot_C(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_c_veq_C_dot_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_c_veq_C_dot_C(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_c_veq_C_dot_C(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_D_r_eq_re_C_dot_C(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_re_C_dot_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_re_C_dot_C(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_re_C_dot_C(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_D_r_veq_re_C_dot_C(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_veq_re_C_dot_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_veq_re_C_dot_C(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_veq_re_C_dot_C(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_D_r_eq_sum_I(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_sum_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_sum_I(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_sum_I(_dest, _src, _subset); \
  } \
}
#define QDP_D_r_eq_sum_R(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_sum_R"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_sum_R(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_sum_R(_dest, _src, _subset); \
  } \
}
#define QDP_D_c_eq_sum_C(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_c_eq_sum_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_D_c_eq_sum_C(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_c_eq_sum_C(_dest, _src, _subset); \
  } \
}
#define QDP_D_r_eq_norm2_I_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_norm2_I_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_norm2_I_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_norm2_I_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_D_r_eq_norm2_R_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_norm2_R_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_norm2_R_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_norm2_R_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_D_r_eq_norm2_C_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_norm2_C_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_norm2_C_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_norm2_C_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_D_r_veq_norm2_I_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_veq_norm2_I_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_veq_norm2_I_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_veq_norm2_I_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_D_r_veq_norm2_R_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_veq_norm2_R_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_veq_norm2_R_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_veq_norm2_R_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_D_r_veq_norm2_C_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_veq_norm2_C_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_veq_norm2_C_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_veq_norm2_C_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_D_r_eq_I_dot_I_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_I_dot_I_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_I_dot_I_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_I_dot_I_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_D_r_eq_R_dot_R_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_R_dot_R_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_R_dot_R_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_R_dot_R_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_D_r_veq_I_dot_I_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_veq_I_dot_I_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_veq_I_dot_I_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_veq_I_dot_I_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_D_r_veq_R_dot_R_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_veq_R_dot_R_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_veq_R_dot_R_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_veq_R_dot_R_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_D_c_eq_C_dot_C_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_c_eq_C_dot_C_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_c_eq_C_dot_C_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_c_eq_C_dot_C_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_D_c_veq_C_dot_C_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_c_veq_C_dot_C_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_c_veq_C_dot_C_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_c_veq_C_dot_C_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_D_r_eq_re_C_dot_C_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_re_C_dot_C_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_re_C_dot_C_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_re_C_dot_C_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_D_r_veq_re_C_dot_C_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_veq_re_C_dot_C_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_veq_re_C_dot_C_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_veq_re_C_dot_C_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_D_r_eq_sum_I_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_sum_I_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_sum_I_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_sum_I_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_D_r_eq_sum_R_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_r_eq_sum_R_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_r_eq_sum_R_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_r_eq_sum_R_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_D_c_eq_sum_C_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_D_c_eq_sum_C_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_D_c_eq_sum_C_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_D_c_eq_sum_C_multi(_dest, _src, _subset, _ns); \
  } \
}

#endif
