/* QDP profiling header for F3 */

#ifndef _QDP_F3_PROFILE_H
#define _QDP_F3_PROFILE_H
#define QDP_F3_V_eq_func(_dest, _func, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_func"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_func(_dest, _func, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_func(_dest, _func, _subset); \
  } \
}
#define QDP_F3_H_eq_func(_dest, _func, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_func"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_func(_dest, _func, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_func(_dest, _func, _subset); \
  } \
}
#define QDP_F3_D_eq_func(_dest, _func, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_func"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_func(_dest, _func, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_func(_dest, _func, _subset); \
  } \
}
#define QDP_F3_M_eq_func(_dest, _func, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_func"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_func(_dest, _func, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_func(_dest, _func, _subset); \
  } \
}
#define QDP_F3_P_eq_func(_dest, _func, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_func"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_func(_dest, _func, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_func(_dest, _func, _subset); \
  } \
}
#define QDP_F3_V_eq_sV(_dest, _src, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_V_eq_sV(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_V_eq_sV(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_V_eq_sV(_dest, _src, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_V_eq_sV(_dest, _src, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_veq_sV(_dest, _src, _shift, _fb, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_V_veq_sV(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_V_veq_sV(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_V_veq_sV(_dest, _src, _shift, _fb, _subset, _nv); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += _nv*QDP_subset_len(_subset); \
  } else { \
    QDP_F3_V_veq_sV(_dest, _src, _shift, _fb, _subset, _nv); \
  } \
}
#define QDP_F3_H_eq_sH(_dest, _src, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_H_eq_sH(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_H_eq_sH(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_H_eq_sH(_dest, _src, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_H_eq_sH(_dest, _src, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_veq_sH(_dest, _src, _shift, _fb, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_H_veq_sH(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_H_veq_sH(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_H_veq_sH(_dest, _src, _shift, _fb, _subset, _nv); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += _nv*QDP_subset_len(_subset); \
  } else { \
    QDP_F3_H_veq_sH(_dest, _src, _shift, _fb, _subset, _nv); \
  } \
}
#define QDP_F3_D_eq_sD(_dest, _src, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_D_eq_sD(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_D_eq_sD(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_D_eq_sD(_dest, _src, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_D_eq_sD(_dest, _src, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_veq_sD(_dest, _src, _shift, _fb, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_D_veq_sD(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_D_veq_sD(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_D_veq_sD(_dest, _src, _shift, _fb, _subset, _nv); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += _nv*QDP_subset_len(_subset); \
  } else { \
    QDP_F3_D_veq_sD(_dest, _src, _shift, _fb, _subset, _nv); \
  } \
}
#define QDP_F3_M_eq_sM(_dest, _src, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_M_eq_sM(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_M_eq_sM(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_M_eq_sM(_dest, _src, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_M_eq_sM(_dest, _src, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_veq_sM(_dest, _src, _shift, _fb, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_M_veq_sM(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_M_veq_sM(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_M_veq_sM(_dest, _src, _shift, _fb, _subset, _nv); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += _nv*QDP_subset_len(_subset); \
  } else { \
    QDP_F3_M_veq_sM(_dest, _src, _shift, _fb, _subset, _nv); \
  } \
}
#define QDP_F3_P_eq_sP(_dest, _src, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_P_eq_sP(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_P_eq_sP(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_P_eq_sP(_dest, _src, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_P_eq_sP(_dest, _src, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_veq_sP(_dest, _src, _shift, _fb, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_P_veq_sP(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_P_veq_sP(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_P_veq_sP(_dest, _src, _shift, _fb, _subset, _nv); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += _nv*QDP_subset_len(_subset); \
  } else { \
    QDP_F3_P_veq_sP(_dest, _src, _shift, _fb, _subset, _nv); \
  } \
}
#define QDP_F3_V_eq_M_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_M_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_M_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_M_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_eq_Ma_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_Ma_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_Ma_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_Ma_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_eq_sM_times_V(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_V_eq_sM_times_V(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_V_eq_sM_times_V(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_V_eq_sM_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_V_eq_sM_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_eq_sMa_times_V(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_V_eq_sMa_times_V(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_V_eq_sMa_times_V(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_V_eq_sMa_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_V_eq_sMa_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_eq_sM_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_V_eq_sM_times_sV(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_V_eq_sM_times_sV(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_V_eq_sM_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_V_eq_sM_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_eq_sMa_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_V_eq_sMa_times_sV(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_V_eq_sMa_times_sV(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_V_eq_sMa_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_V_eq_sMa_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_peq_M_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_peq_M_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_peq_M_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_peq_M_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_peq_Ma_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_peq_Ma_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_peq_Ma_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_peq_Ma_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_peq_sM_times_V(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_peq_sM_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_peq_sM_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_peq_sM_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_peq_sMa_times_V(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_peq_sMa_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_peq_sMa_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_peq_sMa_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_peq_sM_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_peq_sM_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_peq_sM_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_peq_sM_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_peq_sMa_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_peq_sMa_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_peq_sMa_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_peq_sMa_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_meq_M_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_meq_M_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_meq_M_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_meq_M_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_meq_Ma_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_meq_Ma_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_meq_Ma_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_meq_Ma_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_meq_sM_times_V(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_meq_sM_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_meq_sM_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_meq_sM_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_meq_sMa_times_V(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_meq_sMa_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_meq_sMa_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_meq_sMa_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_meq_sM_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_meq_sM_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_meq_sM_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_meq_sM_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_meq_sMa_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_meq_sMa_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_meq_sMa_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_meq_sMa_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_eqm_M_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eqm_M_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eqm_M_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eqm_M_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_eqm_Ma_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eqm_Ma_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eqm_Ma_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eqm_Ma_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_eqm_sM_times_V(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eqm_sM_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eqm_sM_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eqm_sM_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_eqm_sMa_times_V(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eqm_sMa_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eqm_sMa_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eqm_sMa_times_V(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_eqm_sM_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eqm_sM_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eqm_sM_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eqm_sM_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_eqm_sMa_times_sV(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eqm_sMa_times_sV"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eqm_sMa_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eqm_sMa_times_sV(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_eq_M_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_M_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_M_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_M_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_eq_Ma_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_Ma_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_Ma_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_Ma_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_eq_sM_times_H(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_H_eq_sM_times_H(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_H_eq_sM_times_H(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_H_eq_sM_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_H_eq_sM_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_eq_sMa_times_H(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_H_eq_sMa_times_H(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_H_eq_sMa_times_H(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_H_eq_sMa_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_H_eq_sMa_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_eq_sM_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_H_eq_sM_times_sH(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_H_eq_sM_times_sH(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_H_eq_sM_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_H_eq_sM_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_eq_sMa_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_H_eq_sMa_times_sH(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_H_eq_sMa_times_sH(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_H_eq_sMa_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_H_eq_sMa_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_peq_M_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_peq_M_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_peq_M_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_peq_M_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_peq_Ma_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_peq_Ma_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_peq_Ma_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_peq_Ma_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_peq_sM_times_H(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_peq_sM_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_peq_sM_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_peq_sM_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_peq_sMa_times_H(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_peq_sMa_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_peq_sMa_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_peq_sMa_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_peq_sM_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_peq_sM_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_peq_sM_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_peq_sM_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_peq_sMa_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_peq_sMa_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_peq_sMa_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_peq_sMa_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_meq_M_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_meq_M_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_meq_M_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_meq_M_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_meq_Ma_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_meq_Ma_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_meq_Ma_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_meq_Ma_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_meq_sM_times_H(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_meq_sM_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_meq_sM_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_meq_sM_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_meq_sMa_times_H(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_meq_sMa_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_meq_sMa_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_meq_sMa_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_meq_sM_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_meq_sM_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_meq_sM_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_meq_sM_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_meq_sMa_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_meq_sMa_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_meq_sMa_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_meq_sMa_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_eqm_M_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eqm_M_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eqm_M_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eqm_M_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_eqm_Ma_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eqm_Ma_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eqm_Ma_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eqm_Ma_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_eqm_sM_times_H(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eqm_sM_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eqm_sM_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eqm_sM_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_eqm_sMa_times_H(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eqm_sMa_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eqm_sMa_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eqm_sMa_times_H(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_eqm_sM_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eqm_sM_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eqm_sM_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eqm_sM_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_H_eqm_sMa_times_sH(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eqm_sMa_times_sH"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eqm_sMa_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eqm_sMa_times_sH(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_eq_M_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_M_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_M_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_M_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_eq_Ma_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_Ma_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_Ma_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_Ma_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_eq_sM_times_D(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_D_eq_sM_times_D(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_D_eq_sM_times_D(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_D_eq_sM_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_D_eq_sM_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_eq_sMa_times_D(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_D_eq_sMa_times_D(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_D_eq_sMa_times_D(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_D_eq_sMa_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_D_eq_sMa_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_eq_sM_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_D_eq_sM_times_sD(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_D_eq_sM_times_sD(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_D_eq_sM_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_D_eq_sM_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_eq_sMa_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_D_eq_sMa_times_sD(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_D_eq_sMa_times_sD(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_D_eq_sMa_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_D_eq_sMa_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_peq_M_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_M_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_M_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_M_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_peq_Ma_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_Ma_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_Ma_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_Ma_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_peq_sM_times_D(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_sM_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_sM_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_sM_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_peq_sMa_times_D(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_sMa_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_sMa_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_sMa_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_peq_sM_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_sM_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_sM_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_sM_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_peq_sMa_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_sMa_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_sMa_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_sMa_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_meq_M_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_M_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_M_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_M_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_meq_Ma_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_Ma_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_Ma_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_Ma_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_meq_sM_times_D(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_sM_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_sM_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_sM_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_meq_sMa_times_D(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_sMa_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_sMa_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_sMa_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_meq_sM_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_sM_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_sM_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_sM_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_meq_sMa_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_sMa_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_sMa_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_sMa_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_eqm_M_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_M_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_M_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_M_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_eqm_Ma_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_Ma_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_Ma_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_Ma_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_eqm_sM_times_D(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_sM_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_sM_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_sM_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_eqm_sMa_times_D(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_sMa_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_sMa_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_sMa_times_D(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_eqm_sM_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_sM_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_sM_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_sM_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_D_eqm_sMa_times_sD(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_sMa_times_sD"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_sMa_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_sMa_times_sD(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_eq_M_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_M_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_M_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_M_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_eq_Ma_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_Ma_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_Ma_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_Ma_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_eq_sM_times_M(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_M_eq_sM_times_M(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_M_eq_sM_times_M(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_M_eq_sM_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_M_eq_sM_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_eq_sMa_times_M(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_M_eq_sMa_times_M(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_M_eq_sMa_times_M(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_M_eq_sMa_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_M_eq_sMa_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_eq_sM_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_M_eq_sM_times_sM(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_M_eq_sM_times_sM(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_M_eq_sM_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_M_eq_sM_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_eq_sMa_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_M_eq_sMa_times_sM(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_M_eq_sMa_times_sM(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_M_eq_sMa_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_M_eq_sMa_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_peq_M_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_M_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_M_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_M_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_peq_Ma_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_Ma_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_Ma_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_Ma_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_peq_sM_times_M(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_sM_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_sM_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_sM_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_peq_sMa_times_M(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_sMa_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_sMa_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_sMa_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_peq_sM_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_sM_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_sM_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_sM_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_peq_sMa_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_sMa_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_sMa_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_sMa_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_meq_M_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_M_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_M_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_M_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_meq_Ma_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_Ma_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_Ma_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_Ma_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_meq_sM_times_M(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_sM_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_sM_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_sM_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_meq_sMa_times_M(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_sMa_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_sMa_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_sMa_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_meq_sM_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_sM_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_sM_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_sM_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_meq_sMa_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_sMa_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_sMa_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_sMa_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_eqm_M_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_M_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_M_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_M_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_eqm_Ma_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_Ma_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_Ma_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_Ma_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_eqm_sM_times_M(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_sM_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_sM_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_sM_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_eqm_sMa_times_M(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_sMa_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_sMa_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_sMa_times_M(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_eqm_sM_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_sM_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_sM_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_sM_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_M_eqm_sMa_times_sM(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_sMa_times_sM"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_sMa_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_sMa_times_sM(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_eq_M_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_M_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_M_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_M_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_eq_Ma_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_Ma_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_Ma_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_Ma_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_eq_sM_times_P(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_P_eq_sM_times_P(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_P_eq_sM_times_P(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_P_eq_sM_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_P_eq_sM_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_eq_sMa_times_P(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_P_eq_sMa_times_P(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_P_eq_sMa_times_P(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_P_eq_sMa_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_P_eq_sMa_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_eq_sM_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_P_eq_sM_times_sP(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_P_eq_sM_times_sP(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_P_eq_sM_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_P_eq_sM_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_eq_sMa_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp[2]; \
    static int first_time=1; \
    double _time; \
    if(first_time) { \
      first_time = 0; \
      qp[0].count = 0; \
      qp[0].time = 0; \
      qp[0].comm_time = 0; \
      qp[0].math_time = 0; \
      qp[0].nsites = 0; \
      qp[0].func = "QDP_F3_P_eq_sMa_times_sP(no restart)"; \
      qp[0].caller = __func__; \
      qp[0].line = __LINE__; \
      QDP_register_prof(&qp[0]); \
      qp[1].count = 0; \
      qp[1].time = 0; \
      qp[1].comm_time = 0; \
      qp[1].math_time = 0; \
      qp[1].nsites = 0; \
      qp[1].func = "QDP_F3_P_eq_sMa_times_sP(restart)"; \
      qp[1].caller = __func__; \
      qp[1].line = __LINE__; \
      QDP_register_prof(&qp[1]); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    _time = QDP_time(); \
    QDP_F3_P_eq_sMa_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp[QDP_restart].time += QDP_time() - _time; \
    QDP_keep_time = 0; \
    qp[QDP_restart].comm_time += QDP_comm_time; \
    qp[QDP_restart].math_time += QDP_math_time; \
    qp[QDP_restart].count++; \
    qp[QDP_restart].nsites += QDP_subset_len(_subset); \
  } else { \
    QDP_F3_P_eq_sMa_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_peq_M_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_M_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_M_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_M_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_peq_Ma_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_Ma_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_Ma_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_Ma_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_peq_sM_times_P(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_sM_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_sM_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_sM_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_peq_sMa_times_P(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_sMa_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_sMa_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_sMa_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_peq_sM_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_sM_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_sM_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_sM_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_peq_sMa_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_sMa_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_sMa_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_sMa_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_meq_M_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_M_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_M_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_M_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_meq_Ma_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_Ma_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_Ma_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_Ma_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_meq_sM_times_P(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_sM_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_sM_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_sM_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_meq_sMa_times_P(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_sMa_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_sMa_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_sMa_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_meq_sM_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_sM_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_sM_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_sM_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_meq_sMa_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_sMa_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_sMa_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_sMa_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_eqm_M_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_M_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_M_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_M_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_eqm_Ma_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_Ma_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_Ma_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_Ma_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_eqm_sM_times_P(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_sM_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_sM_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_sM_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_eqm_sMa_times_P(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_sMa_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_sMa_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_sMa_times_P(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_eqm_sM_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_sM_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_sM_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_sM_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_P_eqm_sMa_times_sP(_dest, _src1, _src2, _shift, _fb, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_sMa_times_sP"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_sMa_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_sMa_times_sP(_dest, _src1, _src2, _shift, _fb, _subset); \
  } \
}
#define QDP_F3_V_eq_zero(_dest, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_zero"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_zero(_dest, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_zero(_dest, _subset); \
  } \
}
#define QDP_F3_H_eq_zero(_dest, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_zero"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_zero(_dest, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_zero(_dest, _subset); \
  } \
}
#define QDP_F3_D_eq_zero(_dest, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_zero"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_zero(_dest, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_zero(_dest, _subset); \
  } \
}
#define QDP_F3_M_eq_zero(_dest, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_zero"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_zero(_dest, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_zero(_dest, _subset); \
  } \
}
#define QDP_F3_P_eq_zero(_dest, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_zero"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_zero(_dest, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_zero(_dest, _subset); \
  } \
}
#define QDP_F3_V_eq_v(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_v"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_v(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_v(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_eq_h(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_h"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_h(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_h(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_eq_d(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_d"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_d(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_d(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eq_m(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_m"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_m(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_m(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_eq_p(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_p"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_p(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_p(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eq_c(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_c"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_c(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_c(_dest, _src, _subset); \
  } \
}
#define QDP_F3_V_eq_gaussian_S(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_gaussian_S"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_gaussian_S(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_gaussian_S(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_eq_gaussian_S(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_gaussian_S"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_gaussian_S(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_gaussian_S(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_eq_gaussian_S(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_gaussian_S"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_gaussian_S(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_gaussian_S(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eq_gaussian_S(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_gaussian_S"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_gaussian_S(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_gaussian_S(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_eq_gaussian_S(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_gaussian_S"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_gaussian_S(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_gaussian_S(_dest, _src, _subset); \
  } \
}
#define QDP_F3_V_eq_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_eq_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_eq_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eq_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_eq_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_V_veq_V(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_veq_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_veq_V(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_veq_V(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_H_veq_H(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_veq_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_veq_H(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_veq_H(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_D_veq_D(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_veq_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_veq_D(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_veq_D(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_M_veq_M(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_veq_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_veq_M(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_veq_M(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_P_veq_P(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_veq_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_veq_P(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_veq_P(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_V_eqm_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eqm_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eqm_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eqm_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_eqm_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eqm_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eqm_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eqm_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_eqm_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eqm_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_eqm_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_V_peq_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_peq_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_peq_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_peq_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_peq_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_peq_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_peq_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_peq_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_peq_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_peq_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_peq_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_V_meq_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_meq_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_meq_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_meq_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_meq_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_meq_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_meq_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_meq_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_meq_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_meq_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_meq_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_V_veqm_V(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_veqm_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_veqm_V(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_veqm_V(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_H_veqm_H(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_veqm_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_veqm_H(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_veqm_H(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_D_veqm_D(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_veqm_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_veqm_D(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_veqm_D(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_M_veqm_M(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_veqm_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_veqm_M(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_veqm_M(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_P_veqm_P(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_veqm_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_veqm_P(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_veqm_P(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_V_vpeq_V(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_vpeq_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_vpeq_V(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_vpeq_V(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_H_vpeq_H(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_vpeq_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_vpeq_H(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_vpeq_H(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_D_vpeq_D(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_vpeq_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_vpeq_D(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_vpeq_D(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_M_vpeq_M(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_vpeq_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_vpeq_M(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_vpeq_M(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_P_vpeq_P(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_vpeq_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_vpeq_P(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_vpeq_P(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_V_vmeq_V(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_vmeq_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_vmeq_V(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_vmeq_V(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_H_vmeq_H(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_vmeq_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_vmeq_H(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_vmeq_H(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_D_vmeq_D(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_vmeq_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_vmeq_D(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_vmeq_D(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_M_vmeq_M(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_vmeq_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_vmeq_M(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_vmeq_M(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_P_vmeq_P(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_vmeq_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_vmeq_P(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_vmeq_P(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_M_eq_transpose_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_transpose_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_transpose_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_transpose_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_eq_transpose_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_transpose_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_transpose_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_transpose_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_peq_transpose_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_transpose_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_transpose_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_transpose_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_peq_transpose_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_transpose_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_transpose_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_transpose_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_meq_transpose_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_transpose_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_transpose_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_transpose_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_meq_transpose_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_transpose_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_transpose_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_transpose_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eqm_transpose_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_transpose_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_transpose_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_transpose_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_eqm_transpose_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_transpose_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_transpose_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_transpose_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_V_eq_conj_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_conj_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_conj_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_conj_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_eq_conj_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_conj_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_conj_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_conj_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_eq_conj_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_conj_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_conj_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_conj_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eq_conj_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_conj_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_conj_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_conj_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_eq_conj_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_conj_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_conj_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_conj_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_V_peq_conj_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_peq_conj_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_peq_conj_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_peq_conj_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_peq_conj_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_peq_conj_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_peq_conj_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_peq_conj_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_peq_conj_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_conj_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_conj_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_conj_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_peq_conj_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_conj_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_conj_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_conj_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_peq_conj_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_conj_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_conj_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_conj_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_V_meq_conj_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_meq_conj_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_meq_conj_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_meq_conj_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_meq_conj_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_meq_conj_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_meq_conj_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_meq_conj_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_meq_conj_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_conj_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_conj_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_conj_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_meq_conj_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_conj_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_conj_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_conj_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_meq_conj_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_conj_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_conj_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_conj_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_V_eqm_conj_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eqm_conj_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eqm_conj_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eqm_conj_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_eqm_conj_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eqm_conj_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eqm_conj_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eqm_conj_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_eqm_conj_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_conj_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_conj_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_conj_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eqm_conj_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_conj_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_conj_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_conj_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_eqm_conj_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_conj_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_conj_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_conj_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eq_Ma(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_Ma(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_Ma(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_eq_Pa(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_Pa"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_Pa(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_Pa(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_peq_Ma(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_Ma(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_Ma(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_peq_Pa(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_Pa"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_Pa(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_Pa(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_meq_Ma(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_Ma(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_Ma(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_meq_Pa(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_Pa"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_Pa(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_Pa(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eqm_Ma(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_Ma(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_Ma(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_eqm_Pa(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_Pa"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_Pa(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_Pa(_dest, _src, _subset); \
  } \
}
#define QDP_F3_R_eq_norm2_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_R_eq_norm2_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_R_eq_norm2_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_R_eq_norm2_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_R_eq_norm2_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_R_eq_norm2_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_R_eq_norm2_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_R_eq_norm2_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_R_eq_norm2_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_R_eq_norm2_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_R_eq_norm2_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_R_eq_norm2_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_R_eq_norm2_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_R_eq_norm2_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_R_eq_norm2_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_R_eq_norm2_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_R_eq_norm2_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_R_eq_norm2_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_R_eq_norm2_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_R_eq_norm2_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_C_eq_elem_M(_dest, _src, _i, _j, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_C_eq_elem_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_C_eq_elem_M(_dest, _src, _i, _j, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_C_eq_elem_M(_dest, _src, _i, _j, _subset); \
  } \
}
#define QDP_F3_M_eq_elem_C(_dest, _src, _i, _j, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_elem_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_elem_C(_dest, _src, _i, _j, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_elem_C(_dest, _src, _i, _j, _subset); \
  } \
}
#define QDP_F3_C_eq_elem_H(_dest, _src, _color, _spin, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_C_eq_elem_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_C_eq_elem_H(_dest, _src, _color, _spin, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_C_eq_elem_H(_dest, _src, _color, _spin, _subset); \
  } \
}
#define QDP_F3_C_eq_elem_D(_dest, _src, _color, _spin, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_C_eq_elem_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_C_eq_elem_D(_dest, _src, _color, _spin, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_C_eq_elem_D(_dest, _src, _color, _spin, _subset); \
  } \
}
#define QDP_F3_H_eq_elem_C(_dest, _src, _color, _spin, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_elem_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_elem_C(_dest, _src, _color, _spin, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_elem_C(_dest, _src, _color, _spin, _subset); \
  } \
}
#define QDP_F3_D_eq_elem_C(_dest, _src, _color, _spin, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_elem_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_elem_C(_dest, _src, _color, _spin, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_elem_C(_dest, _src, _color, _spin, _subset); \
  } \
}
#define QDP_F3_C_eq_elem_V(_dest, _src, _i, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_C_eq_elem_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_C_eq_elem_V(_dest, _src, _i, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_C_eq_elem_V(_dest, _src, _i, _subset); \
  } \
}
#define QDP_F3_V_eq_elem_C(_dest, _src, _i, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_elem_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_elem_C(_dest, _src, _i, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_elem_C(_dest, _src, _i, _subset); \
  } \
}
#define QDP_F3_C_eq_elem_P(_dest, _src, _ic, _is, _jc, _js, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_C_eq_elem_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_C_eq_elem_P(_dest, _src, _ic, _is, _jc, _js, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_C_eq_elem_P(_dest, _src, _ic, _is, _jc, _js, _subset); \
  } \
}
#define QDP_F3_P_eq_elem_C(_dest, _src, _ic, _is, _jc, _js, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_elem_C"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_elem_C(_dest, _src, _ic, _is, _jc, _js, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_elem_C(_dest, _src, _ic, _is, _jc, _js, _subset); \
  } \
}
#define QDP_F3_V_eq_colorvec_M(_dest, _src, _j, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_colorvec_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_colorvec_M(_dest, _src, _j, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_colorvec_M(_dest, _src, _j, _subset); \
  } \
}
#define QDP_F3_M_eq_colorvec_V(_dest, _src, _j, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_colorvec_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_colorvec_V(_dest, _src, _j, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_colorvec_V(_dest, _src, _j, _subset); \
  } \
}
#define QDP_F3_V_eq_colorvec_H(_dest, _src, _spin, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_colorvec_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_colorvec_H(_dest, _src, _spin, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_colorvec_H(_dest, _src, _spin, _subset); \
  } \
}
#define QDP_F3_V_eq_colorvec_D(_dest, _src, _spin, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_colorvec_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_colorvec_D(_dest, _src, _spin, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_colorvec_D(_dest, _src, _spin, _subset); \
  } \
}
#define QDP_F3_H_eq_colorvec_V(_dest, _src, _spin, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_colorvec_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_colorvec_V(_dest, _src, _spin, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_colorvec_V(_dest, _src, _spin, _subset); \
  } \
}
#define QDP_F3_D_eq_colorvec_V(_dest, _src, _spin, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_colorvec_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_colorvec_V(_dest, _src, _spin, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_colorvec_V(_dest, _src, _spin, _subset); \
  } \
}
#define QDP_F3_D_eq_diracvec_P(_dest, _src, _jc, _js, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_diracvec_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_diracvec_P(_dest, _src, _jc, _js, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_diracvec_P(_dest, _src, _jc, _js, _subset); \
  } \
}
#define QDP_F3_P_eq_diracvec_D(_dest, _src, _jc, _js, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_diracvec_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_diracvec_D(_dest, _src, _jc, _js, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_diracvec_D(_dest, _src, _jc, _js, _subset); \
  } \
}
#define QDP_F3_C_eq_trace_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_C_eq_trace_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_C_eq_trace_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_C_eq_trace_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_R_eq_re_trace_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_R_eq_re_trace_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_R_eq_re_trace_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_R_eq_re_trace_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_R_eq_im_trace_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_R_eq_im_trace_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_R_eq_im_trace_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_R_eq_im_trace_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eq_antiherm_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_antiherm_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_antiherm_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_antiherm_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eq_spintrace_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_spintrace_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_spintrace_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_spintrace_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_eq_spproj_D(_dest, _src, _dir, _sign, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_spproj_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_spproj_D(_dest, _src, _dir, _sign, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_spproj_D(_dest, _src, _dir, _sign, _subset); \
  } \
}
#define QDP_F3_H_veq_spproj_D(_dest, _src, _dir, _sign, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_veq_spproj_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_veq_spproj_D(_dest, _src, _dir, _sign, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_veq_spproj_D(_dest, _src, _dir, _sign, _subset, _nv); \
  } \
}
#define QDP_F3_D_eq_sprecon_H(_dest, _src, _dir, _sign, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_sprecon_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_sprecon_H(_dest, _src, _dir, _sign, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_sprecon_H(_dest, _src, _dir, _sign, _subset); \
  } \
}
#define QDP_F3_D_peq_sprecon_H(_dest, _src, _dir, _sign, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_sprecon_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_sprecon_H(_dest, _src, _dir, _sign, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_sprecon_H(_dest, _src, _dir, _sign, _subset); \
  } \
}
#define QDP_F3_D_meq_sprecon_H(_dest, _src, _dir, _sign, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_sprecon_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_sprecon_H(_dest, _src, _dir, _sign, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_sprecon_H(_dest, _src, _dir, _sign, _subset); \
  } \
}
#define QDP_F3_D_eqm_sprecon_H(_dest, _src, _dir, _sign, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_sprecon_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_sprecon_H(_dest, _src, _dir, _sign, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_sprecon_H(_dest, _src, _dir, _sign, _subset); \
  } \
}
#define QDP_F3_D_veq_sprecon_H(_dest, _src, _dir, _sign, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_veq_sprecon_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_veq_sprecon_H(_dest, _src, _dir, _sign, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_veq_sprecon_H(_dest, _src, _dir, _sign, _subset, _nv); \
  } \
}
#define QDP_F3_D_vpeq_sprecon_H(_dest, _src, _dir, _sign, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_vpeq_sprecon_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_vpeq_sprecon_H(_dest, _src, _dir, _sign, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_vpeq_sprecon_H(_dest, _src, _dir, _sign, _subset, _nv); \
  } \
}
#define QDP_F3_D_vmeq_sprecon_H(_dest, _src, _dir, _sign, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_vmeq_sprecon_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_vmeq_sprecon_H(_dest, _src, _dir, _sign, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_vmeq_sprecon_H(_dest, _src, _dir, _sign, _subset, _nv); \
  } \
}
#define QDP_F3_D_veqm_sprecon_H(_dest, _src, _dir, _sign, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_veqm_sprecon_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_veqm_sprecon_H(_dest, _src, _dir, _sign, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_veqm_sprecon_H(_dest, _src, _dir, _sign, _subset, _nv); \
  } \
}
#define QDP_F3_D_eq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_sprecon_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset); \
  } \
}
#define QDP_F3_D_peq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_sprecon_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset); \
  } \
}
#define QDP_F3_D_meq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_sprecon_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset); \
  } \
}
#define QDP_F3_D_eqm_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_sprecon_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset); \
  } \
}
#define QDP_F3_D_veq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_veq_sprecon_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_veq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_veq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
  } \
}
#define QDP_F3_D_vpeq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_vpeq_sprecon_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_vpeq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_vpeq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
  } \
}
#define QDP_F3_D_vmeq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_vmeq_sprecon_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_vmeq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_vmeq_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
  } \
}
#define QDP_F3_D_veqm_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_veqm_sprecon_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_veqm_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_veqm_sprecon_M_times_H(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
  } \
}
#define QDP_F3_D_eq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_wilsonspin_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset); \
  } \
}
#define QDP_F3_D_peq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_wilsonspin_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset); \
  } \
}
#define QDP_F3_D_meq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_wilsonspin_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset); \
  } \
}
#define QDP_F3_D_eqm_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_wilsonspin_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset); \
  } \
}
#define QDP_F3_D_veq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_veq_wilsonspin_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_veq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_veq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
  } \
}
#define QDP_F3_D_vpeq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_vpeq_wilsonspin_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_vpeq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_vpeq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
  } \
}
#define QDP_F3_D_vmeq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_vmeq_wilsonspin_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_vmeq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_vmeq_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
  } \
}
#define QDP_F3_D_veqm_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_veqm_wilsonspin_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_veqm_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_veqm_wilsonspin_M_times_D(_dest, _src1, _src2, _dir, _sign, _subset, _nv); \
  } \
}
#define QDP_F3_V_eq_r_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_r_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_r_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_r_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eq_r_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_r_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_r_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_r_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eq_r_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_r_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_r_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_r_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_r_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_r_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_r_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_r_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eq_r_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_r_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_r_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_r_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_peq_r_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_peq_r_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_peq_r_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_peq_r_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_peq_r_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_peq_r_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_peq_r_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_peq_r_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_peq_r_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_r_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_r_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_r_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_peq_r_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_r_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_r_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_r_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_peq_r_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_r_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_r_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_r_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_meq_r_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_meq_r_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_meq_r_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_meq_r_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_meq_r_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_meq_r_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_meq_r_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_meq_r_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_meq_r_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_r_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_r_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_r_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_meq_r_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_r_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_r_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_r_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_meq_r_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_r_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_r_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_r_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_eqm_r_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eqm_r_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eqm_r_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eqm_r_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eqm_r_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eqm_r_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eqm_r_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eqm_r_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eqm_r_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_r_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_r_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_r_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eqm_r_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_r_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_r_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_r_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eqm_r_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_r_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_r_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_r_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_eq_c_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_c_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_c_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_c_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eq_c_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_c_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_c_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_c_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eq_c_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_c_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_c_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_c_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_c_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_c_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_c_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_c_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eq_c_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_c_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_c_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_c_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_peq_c_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_peq_c_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_peq_c_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_peq_c_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_peq_c_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_peq_c_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_peq_c_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_peq_c_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_peq_c_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_c_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_c_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_c_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_peq_c_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_c_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_c_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_c_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_peq_c_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_c_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_c_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_c_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_meq_c_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_meq_c_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_meq_c_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_meq_c_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_meq_c_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_meq_c_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_meq_c_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_meq_c_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_meq_c_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_c_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_c_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_c_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_meq_c_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_c_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_c_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_c_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_meq_c_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_c_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_c_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_c_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_eqm_c_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eqm_c_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eqm_c_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eqm_c_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eqm_c_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eqm_c_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eqm_c_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eqm_c_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eqm_c_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_c_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_c_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_c_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eqm_c_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_c_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_c_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_c_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eqm_c_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_c_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_c_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_c_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_eq_i_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_i_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_i_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_i_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_eq_i_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_i_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_i_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_i_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_eq_i_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_i_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_i_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_i_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eq_i_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_i_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_i_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_i_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_eq_i_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_i_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_i_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_i_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_V_peq_i_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_peq_i_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_peq_i_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_peq_i_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_peq_i_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_peq_i_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_peq_i_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_peq_i_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_peq_i_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_i_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_i_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_i_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_peq_i_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_i_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_i_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_i_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_peq_i_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_i_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_i_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_i_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_V_meq_i_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_meq_i_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_meq_i_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_meq_i_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_meq_i_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_meq_i_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_meq_i_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_meq_i_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_meq_i_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_i_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_i_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_i_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_meq_i_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_i_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_i_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_i_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_meq_i_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_i_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_i_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_i_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_V_eqm_i_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eqm_i_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eqm_i_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eqm_i_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_H_eqm_i_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eqm_i_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eqm_i_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eqm_i_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_eqm_i_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_i_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_i_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_i_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_M_eqm_i_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_i_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_i_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_i_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_P_eqm_i_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_i_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_i_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_i_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_D_eq_gamma_times_D(_dest, _src, _i, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_gamma_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_gamma_times_D(_dest, _src, _i, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_gamma_times_D(_dest, _src, _i, _subset); \
  } \
}
#define QDP_F3_P_eq_gamma_times_P(_dest, _src, _i, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_gamma_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_gamma_times_P(_dest, _src, _i, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_gamma_times_P(_dest, _src, _i, _subset); \
  } \
}
#define QDP_F3_P_eq_P_times_gamma(_dest, _src, _i, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_P_times_gamma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_P_times_gamma(_dest, _src, _i, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_P_times_gamma(_dest, _src, _i, _subset); \
  } \
}
#define QDP_F3_V_eq_V_plus_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_V_plus_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_V_plus_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_V_plus_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eq_H_plus_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_H_plus_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_H_plus_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_H_plus_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eq_D_plus_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_D_plus_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_D_plus_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_D_plus_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_M_plus_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_M_plus_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_M_plus_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_M_plus_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eq_P_plus_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_P_plus_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_P_plus_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_P_plus_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_eq_V_minus_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_V_minus_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_V_minus_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_V_minus_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eq_H_minus_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_H_minus_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_H_minus_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_H_minus_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eq_D_minus_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_D_minus_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_D_minus_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_D_minus_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_M_minus_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_M_minus_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_M_minus_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_M_minus_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eq_P_minus_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_P_minus_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_P_minus_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_P_minus_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eq_P_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_P_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_P_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_P_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_peq_P_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_P_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_P_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_P_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_meq_P_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_P_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_P_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_P_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eqm_P_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_P_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_P_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_P_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_eq_M_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_M_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_M_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_M_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eq_M_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_M_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_M_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eq_M_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_M_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_M_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_M_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_M_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_M_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_M_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eq_M_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_M_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_M_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_M_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_peq_M_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_peq_M_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_peq_M_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_peq_M_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_peq_M_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_peq_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_peq_M_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_peq_M_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_peq_M_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_M_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_M_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_peq_M_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_M_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_M_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_M_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_peq_M_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_M_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_M_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_M_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_meq_M_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_meq_M_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_meq_M_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_meq_M_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_meq_M_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_meq_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_meq_M_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_meq_M_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_meq_M_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_M_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_M_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_meq_M_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_M_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_M_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_M_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_meq_M_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_M_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_M_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_M_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_eqm_M_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eqm_M_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eqm_M_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eqm_M_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eqm_M_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eqm_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eqm_M_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eqm_M_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eqm_M_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_M_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_M_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eqm_M_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_M_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_M_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_M_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eqm_M_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_M_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_M_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_M_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_veq_M_times_V(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_veq_M_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_veq_M_times_V(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_veq_M_times_V(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_H_veq_M_times_H(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_veq_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_veq_M_times_H(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_veq_M_times_H(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_D_veq_M_times_D(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_veq_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_veq_M_times_D(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_veq_M_times_D(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_M_veq_M_times_M(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_veq_M_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_veq_M_times_M(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_veq_M_times_M(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_P_veq_M_times_P(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_veq_M_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_veq_M_times_P(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_veq_M_times_P(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_V_vpeq_M_times_V(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_vpeq_M_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_vpeq_M_times_V(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_vpeq_M_times_V(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_H_vpeq_M_times_H(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_vpeq_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_vpeq_M_times_H(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_vpeq_M_times_H(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_D_vpeq_M_times_D(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_vpeq_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_vpeq_M_times_D(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_vpeq_M_times_D(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_M_vpeq_M_times_M(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_vpeq_M_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_vpeq_M_times_M(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_vpeq_M_times_M(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_P_vpeq_M_times_P(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_vpeq_M_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_vpeq_M_times_P(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_vpeq_M_times_P(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_V_vmeq_M_times_V(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_vmeq_M_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_vmeq_M_times_V(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_vmeq_M_times_V(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_H_vmeq_M_times_H(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_vmeq_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_vmeq_M_times_H(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_vmeq_M_times_H(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_D_vmeq_M_times_D(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_vmeq_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_vmeq_M_times_D(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_vmeq_M_times_D(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_M_vmeq_M_times_M(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_vmeq_M_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_vmeq_M_times_M(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_vmeq_M_times_M(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_P_vmeq_M_times_P(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_vmeq_M_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_vmeq_M_times_P(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_vmeq_M_times_P(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_V_veqm_M_times_V(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_veqm_M_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_veqm_M_times_V(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_veqm_M_times_V(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_H_veqm_M_times_H(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_veqm_M_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_veqm_M_times_H(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_veqm_M_times_H(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_D_veqm_M_times_D(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_veqm_M_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_veqm_M_times_D(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_veqm_M_times_D(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_M_veqm_M_times_M(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_veqm_M_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_veqm_M_times_M(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_veqm_M_times_M(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_P_veqm_M_times_P(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_veqm_M_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_veqm_M_times_P(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_veqm_M_times_P(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_V_eq_Ma_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_Ma_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_Ma_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_Ma_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eq_Ma_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_Ma_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_Ma_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_Ma_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eq_Ma_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_Ma_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_Ma_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_Ma_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_Ma_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_Ma_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_Ma_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_Ma_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eq_Ma_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_Ma_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_Ma_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_Ma_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_peq_Ma_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_peq_Ma_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_peq_Ma_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_peq_Ma_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_peq_Ma_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_peq_Ma_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_peq_Ma_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_peq_Ma_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_peq_Ma_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_peq_Ma_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_peq_Ma_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_peq_Ma_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_peq_Ma_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_Ma_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_Ma_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_Ma_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_peq_Ma_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_Ma_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_Ma_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_Ma_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_meq_Ma_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_meq_Ma_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_meq_Ma_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_meq_Ma_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_meq_Ma_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_meq_Ma_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_meq_Ma_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_meq_Ma_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_meq_Ma_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_meq_Ma_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_meq_Ma_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_meq_Ma_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_meq_Ma_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_Ma_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_Ma_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_Ma_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_meq_Ma_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_Ma_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_Ma_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_Ma_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_eqm_Ma_times_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eqm_Ma_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eqm_Ma_times_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eqm_Ma_times_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eqm_Ma_times_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eqm_Ma_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eqm_Ma_times_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eqm_Ma_times_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eqm_Ma_times_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eqm_Ma_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eqm_Ma_times_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eqm_Ma_times_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eqm_Ma_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_Ma_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_Ma_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_Ma_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eqm_Ma_times_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_Ma_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_Ma_times_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_Ma_times_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_veq_Ma_times_V(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_veq_Ma_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_veq_Ma_times_V(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_veq_Ma_times_V(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_H_veq_Ma_times_H(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_veq_Ma_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_veq_Ma_times_H(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_veq_Ma_times_H(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_D_veq_Ma_times_D(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_veq_Ma_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_veq_Ma_times_D(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_veq_Ma_times_D(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_M_veq_Ma_times_M(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_veq_Ma_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_veq_Ma_times_M(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_veq_Ma_times_M(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_P_veq_Ma_times_P(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_veq_Ma_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_veq_Ma_times_P(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_veq_Ma_times_P(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_V_vpeq_Ma_times_V(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_vpeq_Ma_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_vpeq_Ma_times_V(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_vpeq_Ma_times_V(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_H_vpeq_Ma_times_H(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_vpeq_Ma_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_vpeq_Ma_times_H(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_vpeq_Ma_times_H(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_D_vpeq_Ma_times_D(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_vpeq_Ma_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_vpeq_Ma_times_D(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_vpeq_Ma_times_D(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_M_vpeq_Ma_times_M(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_vpeq_Ma_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_vpeq_Ma_times_M(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_vpeq_Ma_times_M(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_P_vpeq_Ma_times_P(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_vpeq_Ma_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_vpeq_Ma_times_P(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_vpeq_Ma_times_P(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_V_vmeq_Ma_times_V(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_vmeq_Ma_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_vmeq_Ma_times_V(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_vmeq_Ma_times_V(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_H_vmeq_Ma_times_H(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_vmeq_Ma_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_vmeq_Ma_times_H(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_vmeq_Ma_times_H(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_D_vmeq_Ma_times_D(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_vmeq_Ma_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_vmeq_Ma_times_D(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_vmeq_Ma_times_D(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_M_vmeq_Ma_times_M(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_vmeq_Ma_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_vmeq_Ma_times_M(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_vmeq_Ma_times_M(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_P_vmeq_Ma_times_P(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_vmeq_Ma_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_vmeq_Ma_times_P(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_vmeq_Ma_times_P(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_V_veqm_Ma_times_V(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_veqm_Ma_times_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_veqm_Ma_times_V(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_veqm_Ma_times_V(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_H_veqm_Ma_times_H(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_veqm_Ma_times_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_veqm_Ma_times_H(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_veqm_Ma_times_H(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_D_veqm_Ma_times_D(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_veqm_Ma_times_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_veqm_Ma_times_D(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_veqm_Ma_times_D(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_M_veqm_Ma_times_M(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_veqm_Ma_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_veqm_Ma_times_M(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_veqm_Ma_times_M(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_P_veqm_Ma_times_P(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_veqm_Ma_times_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_veqm_Ma_times_P(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_veqm_Ma_times_P(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_P_eq_P_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_P_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_P_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_P_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_peq_P_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_P_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_P_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_P_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_meq_P_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_P_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_P_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_P_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eqm_P_times_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_P_times_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_P_times_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_P_times_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_M_times_Ma(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_M_times_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_M_times_Ma(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_M_times_Ma(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eq_P_times_Ma(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_P_times_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_P_times_Ma(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_P_times_Ma(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_peq_M_times_Ma(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_M_times_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_M_times_Ma(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_M_times_Ma(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_peq_P_times_Ma(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_peq_P_times_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_peq_P_times_Ma(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_peq_P_times_Ma(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_meq_M_times_Ma(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_M_times_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_M_times_Ma(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_M_times_Ma(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_meq_P_times_Ma(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_meq_P_times_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_meq_P_times_Ma(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_meq_P_times_Ma(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eqm_M_times_Ma(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_M_times_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_M_times_Ma(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_M_times_Ma(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eqm_P_times_Ma(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eqm_P_times_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eqm_P_times_Ma(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eqm_P_times_Ma(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_Ma_times_Ma(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_Ma_times_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_Ma_times_Ma(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_Ma_times_Ma(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_peq_Ma_times_Ma(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_Ma_times_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_Ma_times_Ma(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_Ma_times_Ma(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_meq_Ma_times_Ma(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_Ma_times_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_Ma_times_Ma(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_Ma_times_Ma(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eqm_Ma_times_Ma(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_Ma_times_Ma"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_Ma_times_Ma(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_Ma_times_Ma(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_C_eq_V_dot_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_C_eq_V_dot_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_C_eq_V_dot_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_C_eq_V_dot_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_C_eq_H_dot_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_C_eq_H_dot_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_C_eq_H_dot_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_C_eq_H_dot_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_C_eq_D_dot_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_C_eq_D_dot_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_C_eq_D_dot_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_C_eq_D_dot_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_C_eq_M_dot_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_C_eq_M_dot_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_C_eq_M_dot_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_C_eq_M_dot_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_C_eq_P_dot_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_C_eq_P_dot_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_C_eq_P_dot_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_C_eq_P_dot_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_R_eq_re_V_dot_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_R_eq_re_V_dot_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_R_eq_re_V_dot_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_R_eq_re_V_dot_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_R_eq_re_H_dot_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_R_eq_re_H_dot_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_R_eq_re_H_dot_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_R_eq_re_H_dot_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_R_eq_re_D_dot_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_R_eq_re_D_dot_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_R_eq_re_D_dot_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_R_eq_re_D_dot_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_R_eq_re_M_dot_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_R_eq_re_M_dot_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_R_eq_re_M_dot_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_R_eq_re_M_dot_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_R_eq_re_P_dot_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_R_eq_re_P_dot_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_R_eq_re_P_dot_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_R_eq_re_P_dot_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_V_times_Va(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_V_times_Va"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_V_times_Va(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_V_times_Va(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_peq_V_times_Va(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_peq_V_times_Va"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_peq_V_times_Va(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_peq_V_times_Va(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_meq_V_times_Va(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_meq_V_times_Va"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_meq_V_times_Va(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_meq_V_times_Va(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eqm_V_times_Va(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eqm_V_times_Va"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eqm_V_times_Va(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eqm_V_times_Va(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_eq_r_times_V_plus_V(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_r_times_V_plus_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_r_times_V_plus_V(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_r_times_V_plus_V(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eq_r_times_H_plus_H(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_r_times_H_plus_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_r_times_H_plus_H(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_r_times_H_plus_H(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eq_r_times_D_plus_D(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_r_times_D_plus_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_r_times_D_plus_D(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_r_times_D_plus_D(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_r_times_M_plus_M(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_r_times_M_plus_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_r_times_M_plus_M(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_r_times_M_plus_M(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eq_r_times_P_plus_P(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_r_times_P_plus_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_r_times_P_plus_P(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_r_times_P_plus_P(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_eq_r_times_V_minus_V(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_r_times_V_minus_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_r_times_V_minus_V(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_r_times_V_minus_V(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eq_r_times_H_minus_H(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_r_times_H_minus_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_r_times_H_minus_H(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_r_times_H_minus_H(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eq_r_times_D_minus_D(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_r_times_D_minus_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_r_times_D_minus_D(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_r_times_D_minus_D(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_r_times_M_minus_M(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_r_times_M_minus_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_r_times_M_minus_M(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_r_times_M_minus_M(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eq_r_times_P_minus_P(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_r_times_P_minus_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_r_times_P_minus_P(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_r_times_P_minus_P(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_eq_c_times_V_plus_V(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_c_times_V_plus_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_c_times_V_plus_V(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_c_times_V_plus_V(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eq_c_times_H_plus_H(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_c_times_H_plus_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_c_times_H_plus_H(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_c_times_H_plus_H(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eq_c_times_D_plus_D(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_c_times_D_plus_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_c_times_D_plus_D(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_c_times_D_plus_D(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_c_times_M_plus_M(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_c_times_M_plus_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_c_times_M_plus_M(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_c_times_M_plus_M(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eq_c_times_P_plus_P(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_c_times_P_plus_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_c_times_P_plus_P(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_c_times_P_plus_P(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_eq_c_times_V_minus_V(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_c_times_V_minus_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_c_times_V_minus_V(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_c_times_V_minus_V(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eq_c_times_H_minus_H(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_c_times_H_minus_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_c_times_H_minus_H(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_c_times_H_minus_H(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eq_c_times_D_minus_D(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_c_times_D_minus_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_c_times_D_minus_D(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_c_times_D_minus_D(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_c_times_M_minus_M(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_c_times_M_minus_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_c_times_M_minus_M(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_c_times_M_minus_M(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eq_c_times_P_minus_P(_dest, _c, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_c_times_P_minus_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_c_times_P_minus_P(_dest, _c, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_c_times_P_minus_P(_dest, _c, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_V_eq_V_mask_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_V_eq_V_mask_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_V_eq_V_mask_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_V_eq_V_mask_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_H_eq_H_mask_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_H_eq_H_mask_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_H_eq_H_mask_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_H_eq_H_mask_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_D_eq_D_mask_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_D_eq_D_mask_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_D_eq_D_mask_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_D_eq_D_mask_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_M_eq_M_mask_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_M_eq_M_mask_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_M_eq_M_mask_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_M_eq_M_mask_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_P_eq_P_mask_I(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_P_eq_P_mask_I"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_P_eq_P_mask_I(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_P_eq_P_mask_I(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_r_eq_norm2_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_norm2_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_norm2_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_norm2_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_r_eq_norm2_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_norm2_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_norm2_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_norm2_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_r_eq_norm2_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_norm2_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_norm2_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_norm2_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_r_eq_norm2_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_norm2_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_norm2_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_norm2_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_r_eq_norm2_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_norm2_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_norm2_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_norm2_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_r_veq_norm2_V(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_norm2_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_norm2_V(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_norm2_V(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_r_veq_norm2_H(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_norm2_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_norm2_H(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_norm2_H(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_r_veq_norm2_D(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_norm2_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_norm2_D(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_norm2_D(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_r_veq_norm2_M(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_norm2_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_norm2_M(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_norm2_M(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_r_veq_norm2_P(_dest, _src, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_norm2_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_norm2_P(_dest, _src, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_norm2_P(_dest, _src, _subset, _nv); \
  } \
}
#define QDP_F3_c_eq_V_dot_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_eq_V_dot_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_c_eq_V_dot_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_eq_V_dot_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_c_eq_H_dot_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_eq_H_dot_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_c_eq_H_dot_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_eq_H_dot_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_c_eq_D_dot_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_eq_D_dot_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_c_eq_D_dot_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_eq_D_dot_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_c_eq_M_dot_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_eq_M_dot_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_c_eq_M_dot_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_eq_M_dot_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_c_eq_P_dot_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_eq_P_dot_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_c_eq_P_dot_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_eq_P_dot_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_c_veq_V_dot_V(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_veq_V_dot_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_c_veq_V_dot_V(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_veq_V_dot_V(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_c_veq_H_dot_H(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_veq_H_dot_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_c_veq_H_dot_H(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_veq_H_dot_H(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_c_veq_D_dot_D(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_veq_D_dot_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_c_veq_D_dot_D(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_veq_D_dot_D(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_c_veq_M_dot_M(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_veq_M_dot_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_c_veq_M_dot_M(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_veq_M_dot_M(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_c_veq_P_dot_P(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_veq_P_dot_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_c_veq_P_dot_P(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_veq_P_dot_P(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_r_eq_re_V_dot_V(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_re_V_dot_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_re_V_dot_V(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_re_V_dot_V(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_r_eq_re_H_dot_H(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_re_H_dot_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_re_H_dot_H(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_re_H_dot_H(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_r_eq_re_D_dot_D(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_re_D_dot_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_re_D_dot_D(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_re_D_dot_D(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_r_eq_re_M_dot_M(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_re_M_dot_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_re_M_dot_M(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_re_M_dot_M(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_r_eq_re_P_dot_P(_dest, _src1, _src2, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_re_P_dot_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_re_P_dot_P(_dest, _src1, _src2, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_re_P_dot_P(_dest, _src1, _src2, _subset); \
  } \
}
#define QDP_F3_r_veq_re_V_dot_V(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_re_V_dot_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_re_V_dot_V(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_re_V_dot_V(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_r_veq_re_H_dot_H(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_re_H_dot_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_re_H_dot_H(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_re_H_dot_H(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_r_veq_re_D_dot_D(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_re_D_dot_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_re_D_dot_D(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_re_D_dot_D(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_r_veq_re_M_dot_M(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_re_M_dot_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_re_M_dot_M(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_re_M_dot_M(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_r_veq_re_P_dot_P(_dest, _src1, _src2, _subset, _nv) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_re_P_dot_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += _nv*QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_re_P_dot_P(_dest, _src1, _src2, _subset, _nv); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_re_P_dot_P(_dest, _src1, _src2, _subset, _nv); \
  } \
}
#define QDP_F3_v_eq_sum_V(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_v_eq_sum_V"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_v_eq_sum_V(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_v_eq_sum_V(_dest, _src, _subset); \
  } \
}
#define QDP_F3_h_eq_sum_H(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_h_eq_sum_H"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_h_eq_sum_H(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_h_eq_sum_H(_dest, _src, _subset); \
  } \
}
#define QDP_F3_d_eq_sum_D(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_d_eq_sum_D"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_d_eq_sum_D(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_d_eq_sum_D(_dest, _src, _subset); \
  } \
}
#define QDP_F3_m_eq_sum_M(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_m_eq_sum_M"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_m_eq_sum_M(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_m_eq_sum_M(_dest, _src, _subset); \
  } \
}
#define QDP_F3_p_eq_sum_P(_dest, _src, _subset) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_p_eq_sum_P"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    qp.nsites += QDP_subset_len(_subset); \
    qp.time -= QDP_time(); \
    QDP_F3_p_eq_sum_P(_dest, _src, _subset); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_p_eq_sum_P(_dest, _src, _subset); \
  } \
}
#define QDP_F3_r_eq_norm2_V_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_norm2_V_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_norm2_V_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_norm2_V_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_r_eq_norm2_H_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_norm2_H_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_norm2_H_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_norm2_H_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_r_eq_norm2_D_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_norm2_D_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_norm2_D_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_norm2_D_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_r_eq_norm2_M_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_norm2_M_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_norm2_M_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_norm2_M_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_r_eq_norm2_P_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_norm2_P_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_norm2_P_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_norm2_P_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_r_veq_norm2_V_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_norm2_V_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_norm2_V_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_norm2_V_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_r_veq_norm2_H_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_norm2_H_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_norm2_H_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_norm2_H_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_r_veq_norm2_D_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_norm2_D_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_norm2_D_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_norm2_D_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_r_veq_norm2_M_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_norm2_M_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_norm2_M_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_norm2_M_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_r_veq_norm2_P_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_norm2_P_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_norm2_P_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_norm2_P_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_c_eq_V_dot_V_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_eq_V_dot_V_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_c_eq_V_dot_V_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_eq_V_dot_V_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_c_eq_H_dot_H_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_eq_H_dot_H_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_c_eq_H_dot_H_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_eq_H_dot_H_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_c_eq_D_dot_D_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_eq_D_dot_D_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_c_eq_D_dot_D_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_eq_D_dot_D_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_c_eq_M_dot_M_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_eq_M_dot_M_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_c_eq_M_dot_M_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_eq_M_dot_M_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_c_eq_P_dot_P_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_eq_P_dot_P_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_c_eq_P_dot_P_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_eq_P_dot_P_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_c_veq_V_dot_V_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_veq_V_dot_V_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_c_veq_V_dot_V_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_veq_V_dot_V_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_c_veq_H_dot_H_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_veq_H_dot_H_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_c_veq_H_dot_H_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_veq_H_dot_H_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_c_veq_D_dot_D_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_veq_D_dot_D_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_c_veq_D_dot_D_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_veq_D_dot_D_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_c_veq_M_dot_M_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_veq_M_dot_M_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_c_veq_M_dot_M_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_veq_M_dot_M_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_c_veq_P_dot_P_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_c_veq_P_dot_P_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_c_veq_P_dot_P_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_c_veq_P_dot_P_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_r_eq_re_V_dot_V_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_re_V_dot_V_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_re_V_dot_V_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_re_V_dot_V_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_r_eq_re_H_dot_H_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_re_H_dot_H_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_re_H_dot_H_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_re_H_dot_H_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_r_eq_re_D_dot_D_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_re_D_dot_D_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_re_D_dot_D_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_re_D_dot_D_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_r_eq_re_M_dot_M_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_re_M_dot_M_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_re_M_dot_M_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_re_M_dot_M_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_r_eq_re_P_dot_P_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_eq_re_P_dot_P_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_eq_re_P_dot_P_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_eq_re_P_dot_P_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_r_veq_re_V_dot_V_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_re_V_dot_V_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_re_V_dot_V_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_re_V_dot_V_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_r_veq_re_H_dot_H_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_re_H_dot_H_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_re_H_dot_H_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_re_H_dot_H_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_r_veq_re_D_dot_D_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_re_D_dot_D_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_re_D_dot_D_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_re_D_dot_D_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_r_veq_re_M_dot_M_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_re_M_dot_M_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_re_M_dot_M_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_re_M_dot_M_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_r_veq_re_P_dot_P_multi(_dest, _src1, _src2, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_r_veq_re_P_dot_P_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_r_veq_re_P_dot_P_multi(_dest, _src1, _src2, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_r_veq_re_P_dot_P_multi(_dest, _src1, _src2, _subset, _ns); \
  } \
}
#define QDP_F3_v_eq_sum_V_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_v_eq_sum_V_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_v_eq_sum_V_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_v_eq_sum_V_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_h_eq_sum_H_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_h_eq_sum_H_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_h_eq_sum_H_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_h_eq_sum_H_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_d_eq_sum_D_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_d_eq_sum_D_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_d_eq_sum_D_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_d_eq_sum_D_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_m_eq_sum_M_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_m_eq_sum_M_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_m_eq_sum_M_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_m_eq_sum_M_multi(_dest, _src, _subset, _ns); \
  } \
}
#define QDP_F3_p_eq_sum_P_multi(_dest, _src, _subset, _ns) { \
  if(QDP_prof_level>0) { \
    static QDP_prof qp; \
    static int first_time=1; \
    if(first_time) { \
      first_time = 0; \
      qp.count = 0; \
      qp.time = 0; \
      qp.comm_time = 0; \
      qp.math_time = 0; \
      qp.nsites = 0; \
      qp.func = "QDP_F3_p_eq_sum_P_multi"; \
      qp.caller = __func__; \
      qp.line = __LINE__; \
      QDP_register_prof(&qp); \
    } \
    QDP_keep_time = 1; \
    QDP_comm_time = 0; \
    QDP_math_time = 0; \
    qp.count++; \
    { int _i; for(_i=0; _i<_ns; ++_i) qp.nsites += QDP_subset_len(_subset[_i]); } \
    qp.time -= QDP_time(); \
    QDP_F3_p_eq_sum_P_multi(_dest, _src, _subset, _ns); \
    qp.time += QDP_time(); \
    QDP_keep_time = 0; \
    qp.comm_time += QDP_comm_time; \
    qp.math_time += QDP_math_time; \
  } else { \
    QDP_F3_p_eq_sum_P_multi(_dest, _src, _subset, _ns); \
  } \
}

#endif
